/*  clock.h
 * 
 *  This include file contains all the constants and structures associated
 *  with the Clock Manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __CLOCK_h
#define __CLOCK_h

#include "tod.h"

/*
 *  _Clock_Get
 *
 *  This routine implements the clock_Get directive.  It returns
 *  the current time of day in the time_buffer record.
 */

Status_Codes _Clock_Get( 
  TOD_Control *time_buffer
);

/*
 *  _Clock_Set
 *
 *  This routine implements the clock_set directive.  It sets
 *  the current time of day to that in the time_buffer record.
 */

Status_Codes _Clock_Set( 
  TOD_Control *time_buffer
);

/*
 *  _Clock_Tick
 *
 *  This routine implements the clock_tick directive.  It is invoked
 *  to inform RTEMS of the occurrence of a clock tick.
 */

Status_Codes _Clock_Tick( void );

#endif
/* end of include file */
