/*  init.h
 * 
 *  This include file contains all the constants and structures associated
 *  with the Initialization Manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __INIT_h
#define __INIT_h

#include "config.h"

/*
 *  _Initialize_Executive
 *
 *  This routine implements the initialize_executive directive.  This
 *  directive is invoked at system startup to initialize the RTEMS
 *  multitasking environment.
 */

void _Initialize_Executive( 
  Configuration_Table *configuration_table, 
  CPU_Table           *cpu_table
);

/*
 *  _Shutdown_Executive
 *
 *  This routine implements the shutdown_executive directive.  The
 *  invocation of this directive results in the RTEMS environment being
 *  shutdown and multitasking halted.  From the application's perspective,
 *  invocation of this directive results in the initialize_executive
 *  directive exitting to the startup code which invoked it.
 */

void _Shutdown_Executive( 
  unsigned32 result
);

#endif
/* end of include file */
