/*  inline/config.inl
 * 
 *  This include file contains the inline routine used in conjunction 
 *  with the table of user defined configuration parameters.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __INLINE_CONFIG_inl
#define __INLINE_CONFIG_inl

/*PAGE
 *
 *  _Configuration_Handler_initialization
 */
 
STATIC INLINE void _Configuration_Handler_initialization(
  Configuration_Table                 *configuration_table,
  Configuration_Multiprocessing_table *multiprocessing_table,
  Configuration_MPCI_table            *users_mpci_table
)
{
  _Configuration_Table = configuration_table;
 
  _Configuration_MP_table   = multiprocessing_table;
  _Configuration_MPCI_table = users_mpci_table;
}

/*PAGE
 *
 *  _Configuration_Is_multiprocessing
 */

STATIC INLINE boolean _Configuration_Is_multiprocessing( void )
{
   return ( _Configuration_MP_table !=
                 &_Configuration_Default_multiprocessing_table );
}

/*PAGE
 *
 *  _Configuration_Is_null_driver_address_table_pointer
 */

STATIC INLINE boolean _Configuration_Is_null_driver_address_table_pointer(
  Configuration_Driver_address_table *the_table
)
{
  return ( the_table == NULL );
}

/*PAGE
 *
 *  _Configuration_Is_null_extension_table_pointer
 */
 
STATIC INLINE boolean _Configuration_Is_null_extension_table_pointer(
  Configuration_Extension_table *the_table
)
{
  return ( the_table == NULL );
}
 
/*PAGE
 *
 *  _Configuration_Is_null_initialization_tasks_table_pointer
 */
 
STATIC INLINE boolean
    _Configuration_Is_null_initialization_tasks_table_pointer(
  Configuration_Initialization_tasks_table *the_table
)
{
  return ( the_table == NULL );
}

#endif
/* end of include file */
