/*  inline/status.inl
 *
 *  This include file contains the implementations of the inlined
 *  routines for the status package.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __INLINE_STATUS_inl
#define __INLINE_STATUS_inl

/*PAGE
 *
 *  _Status_Is_successful
 *
 */

STATIC INLINE boolean _Status_Is_successful( 
  Status_Codes code 
)
{
  return (code == STATUS_SUCCESSFUL);
}

/*PAGE
 *
 *  _Status_Is_equal
 *
 */

STATIC INLINE boolean _Status_Is_equal( 
  Status_Codes code1,
  Status_Codes code2
)
{
   return (code1 == code2);
}

/*
 *  _Status_Is_proxy_blocking
 *
 */
 
STATIC INLINE boolean _Status_Is_proxy_blocking (
  Status_Codes code
)
{
  return (code == STATUS_PROXY_BLOCKING);
}

#endif
/* end of include file */
