/*  intr.h
 * 
 *  This include file contains all the constants and structures associated
 *  with the Interrupt Manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __INTERRUPT_h
#define __INTERRUPT_h

/*
 *  _Interrupt_Catch
 *
 *  This routine implements the interrupt_catch directive.  This
 *  directive installs new_isr_handler as the RTEMS interrupt service
 *  routine for vector.  The previous RTEMS interrupt service
 *  routine is returned in old_isr_handler.
 */

Status_Codes _Interrupt_Catch( 
  proc_ptr    new_isr_handler, 
  unsigned32  vector, 
  proc_ptr   *old_isr_handler
);

#endif
/* end of include file */
