/*  macros/attr.h
 *
 *  This include file contains all of the inlined routines associated
 *  with attributes.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __MACROS_ATTRIBUTES_h
#define __MACROS_ATTRIBUTES_h

/*PAGE
 *
 *  _Attributes_Is_floating_point
 *
 */

#define _Attributes_Is_floating_point( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_FLOATING_POINT )

/*PAGE
 *
 *  _Attributes_Is_global
 *
 */

#define _Attributes_Is_global( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_GLOBAL )

/*PAGE
 *
 *  _Attributes_Is_priority
 *
 */

#define _Attributes_Is_priority( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_PRIORITY )

/*PAGE
 *
 *  _Attributes_Is_limit
 *
 */

#define _Attributes_Is_limit( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_LIMIT )

/*PAGE
 *
 *  _Attributes_Is_binary_semaphore
 *
 */

#define _Attributes_Is_binary_semaphore( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_BINARY_SEMAPHORE )

/*PAGE
 *
 *  _Attributes_Is_inherit_priority
 *
 */

#define _Attributes_Is_inherit_priority( _attribute_set ) \
  ( (_attribute_set) & ATTRIBUTES_INHERIT_PRIORITY )

#endif
/* end of include file */
