/*  macros/config.h
 * 
 *  This include file contains the inline routine used in conjunction 
 *  with the table of user defined configuration parameters.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __MACROS_CONFIG_h
#define __MACROS_CONFIG_h

/*PAGE
 *
 *  _Configuration_Handler_initialization
 */
 
#define _Configuration_Handler_initialization( \
  _configuration_table, _multiprocessing_table, _users_mpci_table ) \
{ \
  _Configuration_Table = (_configuration_table); \
  \
  _Configuration_MP_table   = (_multiprocessing_table); \
  _Configuration_MPCI_table = (_users_mpci_table); \
}

/*PAGE
 *
 *  _Configuration_Is_multiprocessing
 */

#define _Configuration_Is_multiprocessing() \
   ( _Configuration_MP_table != \
                 &_Configuration_Default_multiprocessing_table )

/*PAGE
 *
 *  _Configuration_Is_null_driver_address_table_pointer
 */

#define _Configuration_Is_null_driver_address_table_pointer( _the_table ) \
  ( (_the_table) == NULL )

/*PAGE
 *
 *  _Configuration_Is_null_extension_table_pointer
 */
 
#define _Configuration_Is_null_extension_table_pointer( _the_table ) \
  ( (_the_table) == NULL )
 
/*PAGE
 *
 *  _Configuration_Is_null_initialization_tasks_table_pointer
 */
 
#define \
  _Configuration_Is_null_initialization_tasks_table_pointer( _the_table ) \
    ( (_the_table) == NULL )

#endif
/* end of include file */
