/*  inthrd.inl
 * 
 *  This include file contains the macro implementation of the
 *  inlined routines associated with the RTEMS internal threads.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __INTERNAL_THREADS_inl
#define __INTERNAL_THREADS_inl

/*PAGE
 *
 *  _Internal_threads_Initialize_thread
 *
 */

#define _Internal_threads_Initialize_thread( \
  _the_thread, _its_name, _its_priority, _its_attributes, \
  _its_mode, _entry_point, _stack_size ) \
    { \
      _Stack_Initialize( \
         &(_the_thread)->Start.Initial_stack, \
         _Workspace_Allocate_or_fatal_error( (_stack_size) ), \
         (_stack_size) \
      ); \
 \
      (_the_thread)->name                   = (_its_name); \
      (_the_thread)->attribute_set          = (_its_attributes); \
      (_the_thread)->current_state          = STATES_DORMANT; \
      (_the_thread)->Start.initial_modes    = (_its_mode); \
      (_the_thread)->current_modes          = (_its_mode); \
      (_the_thread)->Start.entry_point      = (_entry_point); \
      (_the_thread)->Start.initial_argument = 0; \
      (_the_thread)->Start.fp_context       = NULL; \
      (_the_thread)->fp_context             = NULL; \
 \
      _Thread_Set_priority( (_the_thread), (_its_priority) ); \
 \
      _Thread_Load_environment( (_the_thread) ); \
    }

#endif
/* end of include file */
