/*  userext.inl
 *
 *  This file contains the macro implementation of the inlined routines
 *  from the User Extension Handler
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __USER_EXTENSIONS_inl
#define __USER_EXTENSIONS_inl

/*PAGE
 *
 *  _User_extensions_Handler_initialization
 *
 */

#define _User_extensions_Handler_initialization( _the_extension_table ) \
  { \
    if ( (_the_extension_table) == NULL ) \
      _User_extensions_Table = _User_extensions_Default_table; \
    else\
      _User_extensions_Table = *(_the_extension_table); \
  }

/*PAGE
 *
 *  _User_extensions_Task_create
 *
 */

#define _User_extensions_Task_create( _the_thread ) \
  if ( _User_extensions_Table.task_create != NULL ) \
    (*_User_extensions_Table.task_create)( _Thread_Executing, _the_thread );

/*PAGE
 *
 *  _User_extensions_Task_delete
 *
 */

#define _User_extensions_Task_delete( _the_thread ) \
  if ( _User_extensions_Table.task_delete != NULL ) \
    (*_User_extensions_Table.task_delete)(_Thread_Executing,(_the_thread));

/*PAGE
 *
 *  _User_extensions_Task_start
 *
 */

#define _User_extensions_Task_start( _the_thread ) \
  if ( _User_extensions_Table.task_start != NULL ) \
    (*_User_extensions_Table.task_start)(_Thread_Executing, (_the_thread));

/*PAGE
 *
 *  _User_extensions_Task_restart
 *
 */

#define _User_extensions_Task_restart( _the_thread ) \
  if ( _User_extensions_Table.task_restart != NULL ) \
    (*_User_extensions_Table.task_restart)(_Thread_Executing,(_the_thread));

/*PAGE
 *
 *  _User_extensions_Task_switch
 *
 */

#define _User_extensions_Task_switch( _executing, _heir ) \
  if ( _User_extensions_Table.task_switch != NULL ) \
    (*_User_extensions_Table.task_switch)( (_executing), (_heir) );

/*PAGE
 *
 *  _User_extensions_Task_exitted
 *
 */

#define _User_extensions_Task_exitted( _executing ) \
  if ( _User_extensions_Table.task_exitted != NULL ) \
    (*_User_extensions_Table.task_exitted)( (_executing) );

/*PAGE
 *
 *  _User_extensions_Fatal
 *
 */

#define _User_extensions_Fatal( _the_error ) \
  if ( _User_extensions_Table.fatal != NULL ) \
    (*_User_extensions_Table.fatal)( (_the_error) );

#endif
/* end of include file */
