/*  mp.h
 * 
 *  This include file contains all the constants and structures associated
 *  with the Multiprocessing Manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __MP_h
#define __MP_h

/*
 *
 *  _Multiprocessing_Manager_initialization
 *
 *  This routine performs the initialization necessary for this manager.
 */

void _Multiprocessing_Manager_initialization ( void );

/*
 *
 *  _Multiprocessing_Announce
 *
 *  This routine implements the MULTIPROCESSING_ANNOUNCE directive.
 *  It is invoked by the MPCI layer to indicate that an MPCI packet
 *  has been received.
 */

void _Multiprocessing_Announce ( void );
 
/*
 *
 *  _Multiprocessing_Receive_server
 *
 *  This routine is a server thread which processes remote requests
 *  from other nodes.
 */
 
void _Multiprocessing_Receive_server ( void );

#endif
/*  end of include file */
