/*  options.h
 *
 *  This include file contains information which defines the 
 *  options available on many directives.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __OPTIONS_h
#define __OPTIONS_h

/*
 *  The following type defines the control block used to manage
 *  option sets.
 */

typedef unsigned32 Options_Control;

/*
 *  The following constants define the individual options which may
 *  be used to compose an option set.
 */

#define OPTIONS_DEFAULT   0x00000000

#define OPTIONS_WAIT      0x00000000        /* wait on resource */
#define OPTIONS_NO_WAIT   0x00000001        /* do not wait on resource */

#define OPTIONS_EVENT_ALL 0x00000000        /* wait for all events */
#define OPTIONS_EVENT_ANY 0x00000002        /* wait on any event */

/*
 *  _Options_Is_no_wait
 *
 *  
 */

STATIC INLINE boolean _Options_Is_no_wait (
  Options_Control option_set
);

/*
 *  _Options_Is_any
 *
 *  
 */

STATIC INLINE boolean _Options_Is_any (
  Options_Control option_set
);

#include "options.inl"

#endif
/* end of include file */
