/*  signal.h
 * 
 *  This include file contains all the constants and structures associated
 *  with the Signal Manager.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __SIGNAL_h
#define __SIGNAL_h

#include "asr.h"
#include "modes.h"
#include "object.h"
#include "status.h"

/*
 *  _Signal_Catch
 *
 *  This routine implements the signal_catch directive.  This directive
 *  is used to establish asr_handler as the Asynchronous Signal Routine
 *  (ASR) for the calling task.  The asr_handler will execute with a
 *  mode of mode_set.
 */

Status_Codes _Signal_Catch( 
  ASR_Handler   asr_handler, 
  Modes_Control mode_set
);

/*
 *  _Signal_Send
 *
 *  This routine implements the signal_send directive.  This directive
 *  sends the signal_set to the task specified by ID.
 */

Status_Codes _Signal_Send( 
  Objects_Id             id, 
  ASR_Signal_set_control signal_set
);

#include "signalmp.h"

#endif
/* end of include file */
