#ifndef _CTYPE_H
#define _CTYPE_H
/*  ctype.h : character classification for GNU cc.
 *
 *  04-Oct-89 Modified to use GNU inline facility. If -traditional is on 
 *            (e.g., __STDC__ is undefined, define as macros instead.
 *            To instantiate copies of the routines that
 *            people who don't include headers can call, set the
 *            __INSTANTIATE_CTYPE__ flag. [atw]
 */

extern	char	_ctype_[];
/* extern	char	_ctype[];	** iC960 R3.0 uses this (sigh) */
#define	_U	0001
#define	_L	0002
#define	_N	0004
#define	_S	0010
#define _P	0020
#define _C	0040
#define _X	0100
#define _SP	0200

#ifdef __STDC__
#ifdef __INSTANTIATE_CTYPE__
#define CTYPE_STATIC
#define CTYPE_INLINE
#else
#define CTYPE_STATIC static
#define CTYPE_INLINE __inline__
#endif
CTYPE_STATIC CTYPE_INLINE const int isalpha(int c) \
	{	return ((_ctype_+1)[c]&(_U|_L));       	};
CTYPE_STATIC CTYPE_INLINE const int isupper(int c) \
	{	return ((_ctype_+1)[c]&_U);		};
CTYPE_STATIC CTYPE_INLINE const int islower(int c) \
	{	return ((_ctype_+1)[c]&_L);		};
CTYPE_STATIC CTYPE_INLINE const int isdigit(int c) \
	{	return ((_ctype_+1)[c]&_N);		};
CTYPE_STATIC CTYPE_INLINE const int isxdigit(int c) \
	{	return ((_ctype_+1)[c]&(_N|_X));       	};
CTYPE_STATIC CTYPE_INLINE const int isspace(int c) \
	{	return ((_ctype_+1)[c]&_S);		};
CTYPE_STATIC CTYPE_INLINE const int ispunct(int c) \
	{	return ((_ctype_+1)[c]&_P);		};
CTYPE_STATIC CTYPE_INLINE const int isalnum(int c) \
	{	return ((_ctype_+1)[c]&(_U|_L|_N));	};
CTYPE_STATIC CTYPE_INLINE const int isprint(int c) \
	{	return ((_ctype_+1)[c]&(_SP|_P|_U|_L|_N));};
CTYPE_STATIC CTYPE_INLINE const int isgraph(int c) \
	{	return ((_ctype_+1)[c]&(_P|_U|_L|_N));	};
CTYPE_STATIC CTYPE_INLINE const int iscntrl(int c) \
	{	return ((_ctype_+1)[c]&_C);		};
CTYPE_STATIC CTYPE_INLINE const int isascii(int c) \
	{	return ((unsigned)(c)<=0177);		};

/* were formerly __STRICT_ANSI__ */
CTYPE_STATIC CTYPE_INLINE const int __toupper(int c) \
	{	return ((c) - 'a' + 'A');			};
CTYPE_STATIC CTYPE_INLINE const int __tolower(int c) \
	{	return ((c) - 'A' + 'a');			};
CTYPE_STATIC CTYPE_INLINE const   int toascii(int c) \
	{	return ((c) & 0177); 				};
CTYPE_STATIC CTYPE_INLINE const   int toupper(int c) \
	{  return( islower(c) ? __toupper(c) : c );	};
CTYPE_STATIC CTYPE_INLINE const   int tolower(int c) \
	{  return( isupper(c) ? __tolower(c) : c );	};
/* end of formerly __STRICT_ANSI__ */

#undef CTYPE_STATIC
#undef CTYPE_INLINE
#else
/*
 * not __STDC__ ... no inlining ... use macros instead.
 */
#define	isalpha(c)	((_ctype_+1)[c]&(_U|_L))
#define	isupper(c)	((_ctype_+1)[c]&_U)
#define	islower(c)	((_ctype_+1)[c]&_L)
#define	isdigit(c)	((_ctype_+1)[c]&_N)
#define	isxdigit(c)	((_ctype_+1)[c]&(_N|_X))
#define	isspace(c)	((_ctype_+1)[c]&_S)
#define ispunct(c)	((_ctype_+1)[c]&_P)
#define isalnum(c)	((_ctype_+1)[c]&(_U|_L|_N))
#define isprint(c)	((_ctype_+1)[c]&(_SP|_P|_U|_L|_N))
#define isgraph(c)	((_ctype_+1)[c]&(_P|_U|_L|_N))
#define iscntrl(c)	((_ctype_+1)[c]&_C)
#define isascii(c)	((unsigned)(c)<=0177)

#ifndef __STRICT_ANSI__
#define __toupper(c)	((c) - 'a' + 'A')
#define __tolower(c)	((c) - 'A' + 'a')
#define   toascii(c)	((c) & 0177)
#define   toupper(c)	(islower(c) ? __toupper(c) : c )
#define   tolower(c)	(isupper(c) ? __tolower(c) : c )
#endif /* STRICT_ANSI */

#endif /* __STDC__ */
#endif /* _CTYPE_H */
