/* 
 * stubs for (future) multi-thread host OS's
 * [atw] 7-Nov-89
 *
 * updated for compatibility with iC960 R3.0 - 3/26/91 - mcg
 */

#ifndef __REENT_H__
#define __REENT_H__

#define _INIT_OK		0
#define _EXIT_INIT_ERROR	1
#define _STDIO_INIT_ERROR	2
#define _THREAD_INIT_ERROR	3
#define _EXIT_PTR		_exit_ptr()
#define _THREAD_PTR		_thread_ptr()

/*
 * need "size_t"
 */
#include <stddef.h>
#define _EXIT_HANDLER_MAX 32
struct _exit
{
	void	*open_stream_sem;
	struct _iobuf	*open_stream_list;	/* the list is maintained as a stack */
	void	*exit_handler_sem;
	int	exit_handler_count;
	void	(*exit_handler_list[_EXIT_HANDLER_MAX])();
};

struct _thread
{
	/* XXX: for iC960 this is 'errno' */
	int		_errno;
	char		*_strtok_buffer;
	struct tm	*_gmtime_buffer;
	void		*_malloc_sem;
	unsigned long	_rand_seed;
	char		_asctime_buffer[26];
};

struct _tzset
{
	char	*_tzname[2];
	long	_timezone;
	int	_daylight;
};

#ifdef __STDIO__
#ifndef _stdio_stream
#define _stdio_stream
struct _stdio
{
	FILE	_stdin;			/* stdin stream */
	FILE	_stdout;		/* stdout stream */
	FILE	_stderr;		/* stderr stream */
};
#endif /* _stdio_stream */
#endif /* __STDIO__ */

void		_exit_init(void);
void		_stdio_init(void);
void		_thread_init(void);
struct _exit	*_exit_create(size_t);
struct _stdio	*_stdio_create(size_t);
struct _thread	*_thread_create(size_t);
struct _exit	*_exit_ptr(void);
struct _stdio	*_stdio_ptr(void);
struct _thread	*_thread_ptr(void);
struct _tzset	*_tzset_ptr(void);
void		_semaphore_init(void **);
void		_semaphore_wait(void **);
void		_semaphore_signal(void **);
void		_semaphore_delete(void **);

#endif /* __REENT_H__ */
