/*
 * <string.h> : string handling routines for gcc960
 */

#ifndef __STRING_H__
#define  __STRING_H__

/*
 * bring in size_t.
 */
#include <stddef.h>

#undef strcat
#undef strchr
#undef strcmp
#undef strcpy
#undef strlen
#undef strncat
#undef strncmp
#undef strncpy
#undef strrchr

#if 0
#define strcat(p,q)		__builtin_strcat(p,q)
#define strchr(p,i)		__builtin_strchr(p,i)
#define strcmp(p,q)		__builtin_strcmp(p,q)
#define strcpy(p,q)		__builtin_strcpy(p,q)
#define strlen(p)		__builtin_strlen(p)
#define strncat(p,q,n)		__builtin_strncat(p,q,n)
#define strncmp(p,q,n)		__builtin_strncmp(p,q,n)
#define strncpy(p,q,n)		__builtin_strncpy(p,q,n)
#define strrchr(p,i)		__builtin_strrchr(p,i)
#endif

#if defined(__STDC__)
/*
 * Prototypes.
 */
char *		(strcat)(char *, const char *);
char *		(strchr)(const char *, int);
int		(strcmp)(const char *, const char *);
char *		(strcpy)(char *, const char *);
size_t		(strcspn)(const char *, const char *);
char *		(strerror)(int);
size_t		(strlen)(const char *);
char *		(strncat)(char *, const char *, size_t);
int		(strncmp)(const char *, const char *, size_t);
char *		(strncpy)(char *, const char *, size_t);
char *		(strpbrk)(const char *, const char *);
int		(strpos)(const char *, char);
char *		(strrchr)(const char *, int);
char *		(strrpbrk)(const char *, const char *);
int		(strrpos)(const char *, char);
size_t		(strspn)(const char *, const char *);
char *		(strstr)(const char *, const char *);
char *		(strtok)(char *, const char *);
int		(strcoll)(const char *, const char *);
size_t		(strxfrm)(char *, const char *, size_t);

#else
/*
 * not STDC, just declare types.
 */
char *		(strcat)();
char *		(strchr)();
int		(strcmp)();
char *		(strcpy)();
size_t		(strcspn)();
char *		(strerror)();
size_t		(strlen)();
char *		(strncat)();
int		(strncmp)();
char *		(strncpy)();
char *		(strpbrk)();
int		(strpos)();
char *		(strrchr)();
char *		(strrpbrk)();
int		(strrpos)();
size_t		(strspn)();
char *		(strstr)();
char *		(strtok)();
int		(strcoll)();
size_t		(strxfrm)();
#endif  /* __STDC__ */

static __inline__ size_t
__builtin_strlen_align_1 (p)
char* p;
{
  char *r = p;
  while (*r++)
    ;
  return r-p-1;
}

static __inline__ char*
__builtin_strcpy_align_1 (p, q)
char* p;
char* q;
{
  char* r = p;
  while ( (*p++ = *q++) )
    ;
  return r;
}

static __inline__ int
__builtin_strcmp_align_1 (s1, s2)
unsigned char* s1;
unsigned char* s2;
{
  while (*s1 != '\0' && *s1 == *s2) {
    s1++;
    s2++;
  }

  return *s1 - *s2;
}
#endif	/* __STRING_H__ */

