/*  timegvar.h  
 *
 *  This header file contains the global variables for the Time
 *  suite.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_unsigned32 end_time;   /* ending time variable */
EXTERN rtems_unsigned32 overhead;   /* loop overhead variable */

EXTERN rtems_id   Task_id[ OPERATION_COUNT+1 ];   /* array of task ids */
EXTERN rtems_id   Task_name[ OPERATION_COUNT+1 ]; /* array of task names */

/* functions */

void Tltimer_init();
int Read_ltimer();

void Timer_initialize();
int Read_timer();

void Clock_check();

rtems_status_code Empty_function( void );

rtems_task Init(
  rtems_task_argument argument
);

#define put_time( _message, _total_time, \
                  _iterations, _loop_overhead, _overhead ) \
    printf( \
      "%s %d\n", \
      (_message), \
      (((_total_time) - (_loop_overhead)) / (_iterations)) - (_overhead) \
    )

/* end of include file */
