#  config.eq
#
#  Configuration table offset constants
#
#  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
#  On-Line Applications Research Corporation (OAR).
#  All rights assigned to U.S. Government, 1994.
#
#  This material may be reproduced by or for the U.S. Government pursuant
#  to the copyright license under the clause at DFARS 252.227-7013.  This
#  notice must appear in all copies of this file and its derivatives.
#
#  $Id$
#

#
#  Offsets of fields in each entry of the RTEMS Initialization Tasks Table 
#
 
.set INIT_TASK_NAME                  , 0
.set INIT_TASK_STACK_SIZE            , INIT_TASK_NAME+4
.set INIT_TASK_INITIAL_PRIORITY      , INIT_TASK_STACK_SIZE+4
.set INIT_TASK_ATTRIBUTE_SET         , INIT_TASK_INITIAL_PRIORITY+4
.set INIT_TASK_ENTRY_POINT           , INIT_TASK_ATTRIBUTE_SET+4
.set INIT_TASK_MODE_SET              , INIT_TASK_ENTRY_POINT+4
.set INIT_TASK_ARGUMENT              , INIT_TASK_MODE_SET+4
.set INIT_TASK_ENTRY_SIZE            , INIT_TASK_ARGUMENT+4

#
#  Offsets of fields in each entry of the RTEMS Device Driver Table 
#
 
.set DEVICE_DRIVER_INITIALIZATION    , 0
.set DEVICE_DRIVER_OPEN              , DEVICE_DRIVER_INITIALIZATION+4
.set DEVICE_DRIVER_CLOSE             , DEVICE_DRIVER_OPEN+4
.set DEVICE_DRIVER_READ              , DEVICE_DRIVER_CLOSE+4
.set DEVICE_DRIVER_WRITE             , DEVICE_DRIVER_READ+4
.set DEVICE_DRIVER_CONTROL           , DEVICE_DRIVER_WRITE+4
.set SIZE_OF_DRIVER_TABLE_ENTRY      , DEVICE_DRIVER_CONTROL+4

#
#  Offsets of fields in the RTEMS Multiprocessor Configuration Table
#
 
.set TASK_CREATE_EXTENSION           , 0
.set TASK_START_EXTENSION            , TASK_CREATE_EXTENSION+4
.set TASK_RESTART_EXTENSION          , TASK_START_EXTENSION+4
.set TASK_DELETE_EXTENSION           , TASK_RESTART_EXTENSION+4
.set TASK_SWITCH_EXTENSION           , TASK_DELETE_EXTENSION+4
.set TASK_EXITTED_EXTENSION          , TASK_SWITCH_EXTENSION+4
.set FATAL_EXTENSION                 , TASK_EXITTED_EXTENSION+4

#
#  Offsets of fields in the RTEMS MPCI Table
#
 
.set MPCI_INITIALIZATION             , 0
.set MPCI_GET_PACKET                 , MPCI_INITIALIZATION+4
.set MPCI_RETURN_PACKET              , MPCI_GET_PACKET+4
.set MPCI_SEND                       , MPCI_RETURN_PACKET+4
.set MPCI_RECEIVE                    , MPCI_SEND+4
.set SIZE_OF_MPCI_TABLE              , MPCI_RECEIVE+4

#
#  Offsets of fields in the RTEMS Multiprocessor Configuration Table
#
 
.set NODE                            , 0
.set MAXIMUM_NODES                   , NODE+4
.set MAXIMUM_GLOBAL_OBJECTS          , MAXIMUM_NODES+4
.set MAXIMUM_PROXIES                 , MAXIMUM_GOBJECTS+4
.set USER_MPCI_TABLE                 , MAXIMUM_PROXIES+4
.set SIZE_OF_MULTIPROCESSOR_TABLE    , USER_MPCI_TABLE+4

#
#  Offsets of fields in the RTEMS Configuration Table 
#
 
.set WORK_SPACE_START                , 0
.set WORK_SPACE_SIZE                 , WORK_SPACE_START+4
.set MAXIMUM_TASKS                   , WORK_SPACE_SIZE+4
.set MAXIMUM_TIMERS                  , MAXIMUM_TASKS+4
.set MAXIMUM_SEMAPHORES              , MAXIMUM_TIMERS+4
.set MAXIMUM_MESSAGE_QUEUES          , MAXIMUM_SEMAPHORES+4
.set MAXIMUM_MESSAGES                , MAXIMUM_MESSAGE_QUEUES+4
.set MAXIMUM_PARTITIONS              , MAXIMUM_MESSAGES+4
.set MAXIMUM_REGIONS                 , MAXIMUM_PARTITIONS+4
.set MAXIMUM_PORTS                   , MAXIMUM_REGIONS+4
.set MAXIMUM_PERIODS                 , MAXIMUM_PORTS+4
.set MILLISECONDS_PER_TICK           , MAXIMUM_PERIODS+4
.set TICKS_PER_TIMESLICE             , MILLISECONDS_PER_TICK+4
.set NUMBER_OF_INITIALIZATION_TASKS  , TICKS_PER_TIMESLICE+4
.set USER_INITIALIZATION_TASKS_TABLE , NUMBER_OF_INITIALIZATION_TASKS+4
.set NUMBER_OF_DEVICE_DRIVERS        , USER_INITIALIZATION_TASKS_TABLE+4
.set DEVICE_DRIVER_TABLE             , NUMBER_OF_DEVICE_DRIVERS+4
.set USER_EXTENSION_TABLE            , DEVICE_DRIVER_TABLE+4
.set USER_MULTIPROCESSING_TABLE      , USER_EXTENSION_TABLE+4
.set SIZE_OF_CONFIGURATION_TABLE     , USER_MULTIPROCESSING_TABLE+4

#  end of config.eq
