/*  rttypes.h
 *
 *  This include file defines the basic data types required by RTEMS
 *  to define all other types and data structures.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __RTEMS_TYPES_h
#define __RTEMS_TYPES_h

/* processor dependent type definitions */

typedef unsigned char  rtems_unsigned8;  /* unsigned 8-bit value  */
typedef unsigned short rtems_unsigned16; /* unsigned 16-bit value */
typedef unsigned int   rtems_unsigned32; /* unsigned 32-bit value */

typedef char           rtems_signed8;    /* signed 8-bit value  */
typedef short          rtems_signed16;   /* signed 16-bit value */
typedef int            rtems_signed32;   /* signed 32-bit value */

typedef float          rtems_single;     /* single precision float */
typedef double         rtems_double;     /* single precision float */

#endif
/* end of include file */
