/*  cvme961.h
 * 
 *  This include file contains some definitions specific to the 
 *  Cyclone CVME960 and CVME961 boards.  These boards are the 
 *  same except the 960 uses SRAM and the 961 DRAM.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __CVME961_h
#define __CVME961_h

/* Constants */

#define FOREVER       1                    /* infinite loop */

/* NINDY console I/O requests:  
 *   CO sends a single character to stdout,
 *   CI reads one.
 */

#define NINDY_INPUT   0
#define NINDY_OUTPUT  1

/* macros */

static inline struct i80960ca_prcb *get_prcb()
{ register struct i80960ca_prcb *_prcb;
  asm volatile( "calls 5; \
                 mov   g0,%0" \
                 : "=d" (_prcb) \
                 : "0" (_prcb) );
  return ( _prcb );
}



/* Structures */

#ifdef C961_INIT
#undef EXTERN
#define EXTERN
#else
#undef EXTERN
#define EXTERN extern
#endif

/* functions */

struct i80960ca_prcb *get_prcb();
void C961_exit();

int _C961_chrdy();
int _C961_inch();
int _C961_outch();

void c961_ioinit();

int NINDY_IO();

/* end of include file */
#endif
