/*  fptest.h
 * 
 *  This include file contains the CPU dependent implementation
 *  of the following routines needed to test RTEMS floating
 *  point support:
 *           FP_load( &context )
 *           FP_check( &context )
 *
 *  FP_load   - loads the specified floating point context
 *  FP_check  - checks the specified floating point context
 *
 *  NOTE:  These routines are VERY CPU dependent and are thus
 *         located in in the CPU dependent include file 
 *         fptest.h.  These routines form the core of the 
 *         floating point context switch test.
 *
 *         i80960CA does not have any hardware floating point
 *         capabilities and this file reflects this.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */


void FP_load( FP_context )
float FP_context[];
{

}

int FP_check( FP_context )
float FP_context[];
{
  return( 0 );           /* indicate FP context matched */
}

void FP_use()
{
}
