/*  dmv152.h
 * 
 *  This include file contains all DMV152 board IO definitions.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __DMV152_h
#define __DMV152_h

#include "rtems.h"
#include "iosupp.h"
#include "z8530.h"

#define USE_CHANNEL_A   0                /* 1 = use channel A for console */
#define USE_CHANNEL_B   1                /* 1 = use channel B for console */

/* Constants */

#define FOREVER       1                  /* infinite loop */

#if (USE_CHANNEL_A == 1)
#define CONSOLE_CONTROL  0x0C800007
#define CONSOLE_DATA     0x0C800005
#elif (USE_CHANNEL_B == 1)
#define CONSOLE_CONTROL  0x0C800001
#define CONSOLE_DATA     0x0C800003
#endif


/* Structures */

#ifdef D152_INIT
#undef EXTERN
#define EXTERN
#else
#undef EXTERN
#define EXTERN extern
#endif

/* functions */

int _D152_chrdy();
int _D152_inch();
int _D152_outch();

/* end of include file */
#endif
