/*  fptest.h
 * 
 *  This include file contains the CPU dependent implementation
 *  of the following routines needed to test RTEMS floating
 *  point support:
 *           FP_load( &context )
 *           FP_check( &context )
 *
 *  FP_load   - loads the specified floating point context
 *  FP_check  - checks the specified floating point context
 *
 *  NOTE:  These routines are VERY CPU dependent and are thus
 *         located in in the CPU dependent include file 
 *         fptest.h.  These routines form the core of the 
 *         floating point context switch test.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

register float rfp2 asm ("fp2");
register float rfp3 asm ("fp3");
register float rfp4 asm ("fp4");
register float rfp5 asm ("fp5");
register float rfp6 asm ("fp6");
register float rfp7 asm ("fp7");

void FP_load( 
  float FP_context[]
)
{
  rfp2 = FP_context[2];
  rfp3 = FP_context[3];
  rfp4 = FP_context[4];
  rfp5 = FP_context[5];
  rfp6 = FP_context[6];
  rfp7 = FP_context[7];
}

int FP_check( 
  float FP_context[]
)
{
  if ( (FP_context[2] == rfp2) && (FP_context[3] == rfp3) &&
       (FP_context[4] == rfp4) && (FP_context[5] == rfp5) &&
       (FP_context[6] == rfp6) && (FP_context[7] == rfp7) )
    return( 0 );
  return( 1 ); 
}

int FP_use( void )
{
  rfp6 = (float) 0x123;
  rfp7 = (float) 0x456; 
  if ( rfp6 == rfp4 || rfp7 == rfp5 )
    return( 0 );
  return( 1 );
}
