/*  time27.h
 * 
 *  This include file contains CPU/target dependent information needed
 *  to generate and time an interrupt.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __TIME27_h
#define __TIME27_h

#include "cpu.h"

#ifdef mvme136
#define MUST_WAIT_FOR_INTERRUPT 0
/* Use the MPCSR vector */
#define Install_tm27_vector( handler ) set_vector( (handler), 75, 1 )
#define Cause_tm27_intr()  (*(volatile rtems_unsigned8 *)0xfffb006b) = 0x80
#define Clear_tm27_intr()  (*(volatile rtems_unsigned8 *)0xfffb006b) = 0x00
#endif

#ifdef dmv152
/* use a VMEbus interrupt */
#define MUST_WAIT_FOR_INTERRUPT 1
#define Install_tm27_vector( handler ) \
  { \
    set_vector( (handler), 0x50, 1 );  \
    (*(volatile rtems_unsigned32 *)0x0d800024) = 0x50; /* set IVECT reg */ \
    (*(volatile rtems_unsigned8  *)0x0d00000c) = 0x40; /* set VIE reg */ \
  }

#define Cause_tm27_intr()  \
  (*(volatile rtems_unsigned8 *)0x0d000003) = 0x0f  /* set VINT */

#define Clear_tm27_intr()  /* no operation necessary */ 

#endif

#endif
/* end of include file */

