/*  int _F386_chrdy( &ch )
 *
 *  This routine returns TRUE if a character is available.
 *
 *  Input parameters: NONE
 *
 *  Output parameters:  NONE
 *
 *  Return values:
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "force386.h"

int _F386_chrdy( ch )
char *ch;
{
  register rtems_unsigned8 status;

  while ( FOREVER ) {
    inport_byte( RX_STATUS, status );
    if ( !Is_rx_ready( status ) ) 
      return( FALSE );

#if ( PORTB == 1 )
    /*
     *  Force example code resets the Channel B Receiver here.
     *  It appears to cause XON's to be lost.
     */

     /* outport_byte( RX_STATUS, 0x10 );  */
#endif

    inport_byte( RX_BUFFER, *ch );    /* get character */

    if ( *ch >= ' ' &&  *ch <= '~' )
      return(TRUE);
  }
}
