/*  int _F386_outch( ch )
 *
 *  This routine transmits a character out the M68681.  It supports
 *  XON/XOFF flow control.
 *
 *  Input parameters:
 *    ch  - character to be transmitted 
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "force386.h"

static inline int _F386_is_rx_ready()
{
  register rtems_unsigned8 status;
  
  inport_byte( RX_STATUS, status );

  if ( Is_rx_ready( status ) ) return TRUE;
  else                         return FALSE;
}

int _F386_outch( ch )
char ch;
{
  register rtems_unsigned8 status;

  do {
    inport_byte( TX_STATUS, status );
  } while ( !Is_tx_ready( status ) );

  while ( _F386_is_rx_ready() == TRUE ) {      /* must be an XOFF */
    inport_byte( RX_BUFFER, status );
    if ( status == XOFF ) 
      do {
        while ( _F386_is_rx_ready() == FALSE ) ;
        inport_byte( RX_BUFFER, status );
      } while ( status != XON ); 
  }

  outport_byte( TX_BUFFER, ch );
  if ( ch == '\n' )
    _F386_outch( CR );
  return( 0 );
}
