/*  bsp_start()
 *
 *  This routine starts the application.  It includes application,
 *  board, and monitor specific initialization and configuration.
 *  The generic CPU dependent initialization has been performed
 *  before this routine is invoked.
 * 
 *  INPUT:  NONE
 * 
 *  OUTPUT: NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "force386.h"
#include "cpu.h"

extern rtems_configuration_table  Configuration;

rtems_cpu_table Cpu_table;

void bsp_start()
{
  register rtems_unsigned16 segment = 0;

  /*
   *  FORCE documentation incorrectly states that the bus request
   *  level is initialized to 3.  It is actually initialized by
   *  FORCEbug to 0.
   */

  outport_byte( 0x00, 0x3f );      /* resets VMEbus request level */

  asm volatile ( "movw %%ds,%0" : "=a" (segment) : "0" (segment) );

  Cpu_table.interrupt_segment      = segment;
  Cpu_table.interrupt_vector_table = (void *)Interrupt_descriptor_table;

  Configuration.work_space_start = (void *)
     0x100000 - Configuration.work_space_size;

  initialize_executive( &Configuration, &Cpu_table ); /* does not return */
}
