/*  Clock_isr
 * 
 *  This routine is the clock tick for a CVME961 VME board running
 *  RTEMS.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "cpu.h"
#include "clockdrv.h"

extern rtems_unsigned32 Clock_isrs;
extern rtems_configuration_table Configuration;

rtems_isr Clock_isr(
  rtems_vector_number vector )
{
  /* enable_tracing(); */
  Clock_driver_ticks += 1; 
  if ( Clock_isrs == 1 ) {
    clock_tick();
    Clock_isrs = Configuration.milliseconds_per_tick;
  }
  else 
    Clock_isrs -= 1;
  clear_intr( 5 );
}
