/*  _Shm_isr()
 *  
 *  NOTE: This routine is not used when in polling mode.  Either
 *        this routine OR Shm_clockisr is used in a particular system.
 *
 *        There must be sufficient time after the IACK (read at
 *        0xb600000x) for the VIC068 to clear the interrupt request
 *        before the interrupt request is cleared from IPND (sf0).
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "cpu.h"
#include "cvme961.h"
#include "shm.h"

rtems_isr Shm_isr()
{
  rtems_unsigned32 vic_vector;

  /* enable_tracing(); */
  vic_vector = (*(volatile rtems_unsigned8 *)0xb6000007); 
                                           /* reset intr by reading */
                                           /*   vector at IPL=3 */
  Shm_isr_count += 1; 
  multiprocessing_announce();
  (*(volatile rtems_unsigned8 *)0xa000005f) = 0; /* clear ICMS0 */
  clear_intr( 6 );
  
}
