/*  void Shm_get_config( localnode, &shmcfg )
 *
 *  This routine initializes, if necessary, and returns a pointer
 *  to the Shared Memory Configuration Table for the DY-4 DMV152.  
 *
 *  INPUT PARAMETERS:
 *    localnode - local node number
 *    shmcfg    - address of pointer to SHM Config Table
 *
 *  OUTPUT PARAMETERS:
 *    *shmcfg   - pointer to SHM Config Table
 *
 *  NOTES:  This routine has not been tested!!!
 *          No attempt has been made to target this routine!!!
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

/*
 *  DMV152 supports some type of MP interrupt.  At least the VMEbus
 *  interrupt could be used.  However, this has not been targetted
 *  yet.  The basic shared memory driver does not support bus 
 *  interrupts such as for the VME which could be used!!!
 */

#define INTERRUPT 0                   /* DMV152 target supports both */
#define POLLING   1                   /* polling and interrupt modes  */

shm_config_table D152_shm_cfgtbl;

void Shm_get_config( localnode, shmcfg )
rtems_unsigned32         localnode;
shm_config_table **shmcfg;
{
   D152_shm_cfgtbl.base         = (rtems_unsigned32 *)0x20000000;
   D152_shm_cfgtbl.length       = 1 * MEGABYTE;
   D152_shm_cfgtbl.format       = SHM_BIG;

#ifdef NEUTRAL_BIG
   D152_shm_cfgtbl.convert      = NULL_CONVERT;
#else
   D152_shm_cfgtbl.convert      = Shm_swap_it;
#endif

#if (POLLING==1)
   D152_shm_cfgtbl.poll_intr    = POLLED_MODE;
   D152_shm_cfgtbl.Intr.address = NO_INTERRUPT;
   D152_shm_cfgtbl.Intr.value   = NO_INTERRUPT;
   D152_shm_cfgtbl.Intr.length  = NO_INTERRUPT;
#else
#error No attempt to support the DMV152 SHM support driver
#endif
   *shmcfg = &D152_shm_cfgtbl;

}
