/*  console( operation, character )
 *
 *  Perform character I/O on console device.
 *
 *  INPUT:
 *    operation - one of following values:
 *      CONSOLE_INPUT  - input a single character
 *      CONSOLE_OUTPUT - output a single character
 *    character - which is either:
 *      pointer to character buffer when CONSOLE_INPUT
 *      actual character to output when CONSOLE_OUTPUT 
 *
 *  OUTPUT:
 *    *character - character input when CONSOLE_INPUT
 *
 *  RETURNS:
 *    CONSOLE_OK    - if successful
 *    CONSOLE_ERROR - otherwise
 *
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "block_io.h"
#include "dmv152.h"

int console( operation, character )  /* perform console IO */
int operation;
int character;
{
  switch ( operation ) {
    case CONSOLE_OUTPUT:
      _D152_outch( (char)character );
      break;
    case CONSOLE_INPUT:
      *((char *)character) = _D152_inch();
      break;
  }
  return CONSOLE_OK;
}
