/*  int _M136_outch( ch )
 *
 *  This routine transmits a character out the M68681.  It supports
 *  XON/XOFF flow control.
 *
 *  Input parameters:
 *    ch  - character to be transmitted 
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "mvme136.h"

int _M136_outch( ch )
char ch;
{
  while ( ! (_Read_m681->srb & TXRDYB) ) ;
  while ( _Read_m681->srb & RXRDYB )        /* must be an XOFF */
    if ( _Read_m681->rbb == XOFF ) 
      do {
        while ( ! (_Read_m681->srb & RXRDYB) ) ;
      } while ( _Read_m681->rbb != XON ); 

  _Write_m681->tbb = ch;
  if ( ch == '\n' )
    _M136_outch( CR );
  return( 0 );
}
