/*  void _Shm_lock( &lq_cb )
 *
 *  This shared memory locked queue support routine locks the 
 *  specified locked queue.  It disables interrupts to prevent 
 *  a deadlock condition.  
 *
 *  Input parameters:
 *    lq_cb - address of queue to lock
 * 
 *  Output parameters: NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "cpu.h"
#include "mvme136.h"
#include "shm.h"

void Shm_lock( lq_cb )
struct lockedq_cb *lq_cb;
{
  rtems_unsigned32 isr_level;
  rtems_unsigned32 *lockptr = &lq_cb->lock;

  disable_intr( isr_level );
    Shm_isrstat = isr_level;
    asm volatile( "lockit:"    : : );
    asm volatile( "tas %0@"    : "=a" (lockptr) : "0" (lockptr) );
    asm volatile( "bne lockit" : : );
/* should delay */
}
