/*
 *  exit
 *  
 *  This routine returns control to 135Bug.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "cpu.h"
#include "z8036.h"

void exit_trap()
{
  set_vbr( 0 );                     /* restore 135Bug vectors */
  asm volatile( "trap   #15"  );    /* trap to 135Bug */
  asm volatile( ".short 0x63" );    /* return to 135Bug (.RETURN) */
  asm volatile( "jmp    start" );   /* restart program */
}

#define TIMER   0xfffb0000

void _exit( )
{
   Z8x36_WRITE( TIMER, MASTER_INTR,    0x62 );   /* redo timer */
   Z8x36_WRITE( TIMER, CT1_MODE_SPEC,  0x00 );
   Z8x36_WRITE( TIMER, MASTER_CFG,     0xf4 );
   Z8x36_WRITE( TIMER, CT1_CMD_STATUS, 0x00 );

   M68Kvec[ 45 ] = exit_trap;   /* install exit_trap handler */
   asm volatile( "trap #13" );  /* insures SUPV mode */
}
