/*  void Shm_cnvpkt( &packet )
 *
 *  This routine is the shared memory locked queue MPCI driver routine
 *  used to convert the RTEMS's information in a packet from non-native
 *  format to processor native format.
 *
 *  Input parameters:
 *    packet  - pointer to a packet
 *
 *  Output parameters:
 *    *packet - packet in native format
 *
 *  NOTE: Message buffers are not manipulated.
 *        Endian conversion is currently the only conversion.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

void Shm_cnvpkt( packet )
rtems_unsigned8 *packet;
{
  rtems_unsigned32 *pkt, i;
  rtems_mp_packet_prefix *prefix;

  pkt = (rtems_unsigned32 *) packet;
  for ( i=MIN_HETERO_CONV ; i ; i--, pkt++ )
    *pkt = Shm_swap_it( *pkt );

  prefix = (rtems_mp_packet_prefix *) packet;

  for ( i=prefix->to_convert ; i ; i--, pkt++ )
    *pkt = Shm_swap_it( *pkt );
}
