/*  struct env_cb *Del_lockedq( lq_cb )
 *
 *  This routine returns an envelope control block from a shared 
 *  memory queue.
 *
 *  Input parameters:
 *    lq_cb - pointer to a locked queue control block
 *
 *  Output parameters:
 *    returns - pointer to an envelope control block 
 *            - NULL if no envelopes on specified queue
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

struct env_cb *Del_lockedq( lq_cb )
struct lockedq_cb *lq_cb;
{
  struct env_cb *tmp_ecb;
  rtems_unsigned32 tmpfront;

  tmp_ecb = NULL_ENV_CB;
  Shm_lock( lq_cb );
     tmpfront = Shm_convert(lq_cb->front);
    if ( tmpfront != LQ_END_OF_LIST ) {
      tmp_ecb = &Envelopes[ tmpfront ];
      lq_cb->front = tmp_ecb->next;
      if ( tmp_ecb->next == LQ_END_OF_LIST ) 
        lq_cb->rear = LQ_END_OF_LIST;
      tmp_ecb->next = LQ_NOT_ON_LIST;
    }
  Shm_unlock( lq_cb );
  return( tmp_ecb );
}
