/*  rtems_task Shm_dump()
 *
 *  This routine is invoked following a reset to report the statistics
 *  gathered during the previous execution.
 *
 *  Input parameters:  NONE
 *
 *  Output parameters: NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"
#include "cpu.h"
#include "stdio.h"

rtems_task Shm_dump(time)
rtems_interval time;
{
  rtems_status_code status;
  int               number_of_packets;

  status = task_wake_after( time );

  delay( 5000 );       /* delay 5000 microseconds */
  number_of_packets = Shm_recvmsgcnt/300;
  if ( Shm_recvmsgcnt % 300  >= 150 )
    number_of_packets++;
  printf( "\n\nSHMDR STATISTICS (NODE %d)\n", Shm_local_node );
  printf( "IDLE TIME = %d / %d\n", Hi_idle, Lo_idle );
  printf( "ISRs=%d\n",     Shm_isr_count );
  printf( "RECV=%d\n",     Shm_recvmsgcnt );
  printf( "NULL=%d\n",     Shm_nullmsgcnt );
  printf( "PKTS/SEC=%d\n", number_of_packets );

  exit( 0 );
}
