/*  void MPCI_fatal( error )
 *
 *  This routine is the shared memory driver fatal error handler.
 *
 *  Input parameters:
 *    error - fatal error code 
 *
 *  Output parameters:  NEVER RETURNS
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

void MPCI_fatal( error )
rtems_unsigned32 error;
{
   /*   Eventually need to attempt to broadcast a K_FATAL message
    *   without checking for all possible errors (do not want to  
    *   recurse).
    *
    *   Also need to avoid using Ns_cbs if the driver has not been 
    *   initialized.
    */

   Ns_cbs[ Shm_local_node ].error = Shm_convert(error);
}
