/*  Shm_getpkt
 *
 *  This routine is the shared memory locked queue MPCI driver
 *  routine used to obtain an empty message packet.
 *
 *  Input parameters:
 *    packet             - address of pointer to packet
 *
 *  Output parameters:
 *    *(cpb->get_packet) - address of allocated packet 
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

rtems_mpci_entry Shm_getpkt( packet )
rtems_unsigned8 **packet;
{
  struct env_cb *ecb;

  Get_envelope( ecb );
  if ( !ecb ) 
    fatal_error_occurred ( SHM_NO_FREE_PKTS );
  *packet = Ecb_to_pkt( ecb );
}
