/*  void Init_lockedq( lq_cb, owner )
 *
 *  This routine initializes a shared memory locked queue.
 *
 *  Input parameters:
 *    lq_cb - pointer to the control block of the queue 
 *            to be initialized 
 *    owner - unique idenitifier of who owns this queue.
 *
 *  Output parameters: NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

void Init_lockedq( lq_cb, owner )
struct lockedq_cb *lq_cb;
rtems_unsigned32 owner;
{
  lq_cb->front     = LQ_END_OF_LIST;
  lq_cb->rear      = LQ_END_OF_LIST;
  lq_cb->lock      = LQ_UNLOCKED;
  lq_cb->owner     = Shm_convert(owner);
}
