/*  Shm_receive
 *
 *  This routine is the shared memory locked queue MPCI driver routine
 *  used to obtain a packet containing a message from this node's 
 *  receive queue.
 *
 *  Input parameters:
 *    packet         - address of a pointer to a packet
 *
 *  Output parameters:
 *    *(rpb->packet) - pointer to packet
 *                     NULL if no packet currently available
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "shm.h"

rtems_mpci_entry Shm_receive( 
  rtems_unsigned8 **packet )
{
  struct env_cb *ecb;

  ecb = Del_recvq( Shm_local_node ); 
  if ( ecb ) {
    *(packet) = Ecb_to_pkt( ecb );
    if ( ecb->Preamble.endian != SHM_ENDIAN )
      Shm_cnvpkt( *packet );
    Shm_recvmsgcnt++;
  } else {
    *(packet) = NULL;
    Shm_nullmsgcnt++;
  }
}
