/*  void _Shm_unlock( &lq_cb )
 *
 *  This shared memory locked queue support routine unlocks the 
 *  specified locked queue.  It restores interrupts to their
 *  previous level.
 *
 *  Input parameters:
 *    lq_cb - address of queue to unlock
 * 
 *  Output parameters: 
 *    NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "cpu.h"
#include "shm.h"

void Shm_unlock( lq_cb )
struct lockedq_cb *lq_cb;
{
  rtems_unsigned32 isr_level;

  lq_cb->lock = 0;
  isr_level = Shm_isrstat; 
  enable_intr( isr_level );
}
