/* 
 *  Currently no file I/O is supported.
 */

#include "stdio.h"
#include <varargs.h>
#include "block_io.h"

int no_file_io()     /* stub for file IO */
{
  return( -1 );
}

int files( va_alist )  /* perform file IO */
va_dcl
{
  va_list        arg;
  int            operation, mode, fd, how, n, status;
  unsigned int   flag;
  long           offset;
  char          *path;
  unsigned char *buffer;
  struct st     *buff;

  status = 0;
  va_start( arg );
  operation = va_arg( arg, int );
  switch ( operation ) {
    case BS_ACCESS:
      path = va_arg( arg, char * );
      mode = va_arg( arg, int );
      status = no_file_io( path, mode );
      break;
    case BS_CLOSE:
      fd = va_arg( arg, int );
      mode = va_arg( arg, int );
      status = no_file_io( fd, mode );
      break;
    case BS_CREAT:
      path = va_arg( arg, char * );
      mode = va_arg( arg, int );
      status = no_file_io( path, mode );
      break;
    case BS_SEEK:
      fd     = va_arg( arg, int );
      offset = va_arg( arg, long );
      how    = va_arg( arg, int );
      status = no_file_io( fd, offset, how );
      break;
    case BS_OPEN:
      path = va_arg( arg, char * );
      flag = va_arg( arg, unsigned int );
      mode = va_arg( arg, int );
      status = no_file_io( path, flag, mode );
      break;
    case BS_READ:
      fd     = va_arg( arg, int );
      buffer = va_arg( arg, unsigned char * );
      n      = va_arg( arg, int );
      status = no_file_io( fd, buffer, n );
      break;
    case BS_STAT:
      path = va_arg( arg, char * );
      buff = va_arg( arg, struct st * );
      status = no_file_io( path, buff );
      break;
    case BS_SYSTEMD:
      path = va_arg( arg, char * );
      status = no_file_io( path );
      break;
    case BS_TIME:
      status = no_file_io();
      break;
    case BS_UNMASK:
      mode = va_arg( arg, int );
      status = no_file_io( mode );
      break;
    case BS_UNLINK:
      path = va_arg( arg, char * );
      status = no_file_io( path );
      break;
    case BS_WRITE:
      fd     = va_arg( arg, int );
      buffer = va_arg( arg, unsigned char * );
      n      = va_arg( arg, int );
      status = no_file_io( fd, buffer, n );
      break;
  }
  va_end( arg );
  return( status );
}

