/*  entry.s
 *
 *  This file contains the entry point for the application.
 *  The name of this entry point is compiler dependent.
 *  It jumps to the BSP which is responsible for performing
 *  all initialization.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 */

include(system.eq)

BEGIN_CODE
                                        | Default entry points for:
         .global start                  |   GNU
         PUBLIC(M68Kvec)                |   Vector Table

LABEL(start) 
LABEL(M68Kvec)                          | standard location for vectors
        nop                             | for linkers with problem
                                        | location zero
        jmp      around
        .space   4088                   | to avoid initial intr stack
                                        |   from 135BUG on MVME13?
                                        |   and start code at 0x4000
vectors:
        .space   1016                   | reserve space for rest of vectors
lowintstack:
        .space   4092                   | reserve for interrupt stack
hiintstack:
        .space   4                      | end of interrupt stack

around: 
        move.w  %sr,initial_sr
        movec   %isp,%a0
        move.l  %a0,initial_isp
        movec   %usp,%a0
        move.l  %a0,initial_usp
        movec   %msp,%a0
        move.l  %a0,initial_msp
        oriw    #0x0700,%sr             | INTERRUPTS OFF!!!

        

        |
        | zero out uninitialized data area
        |
zerobss:
        moveal  #end,%a0                | find end of .bss 
        moveal  #bss_start,%a1          | find beginning of .bss 
        movel   #0,%d0

loop:   movel   #0,%a1@+                | to zero out uninitialized
        cmpal   %a0,%a1
        jlt     loop                    | loop until _end reached 

        movel   #_end,%d0               | d0 = end of bss/start of heap 
        addl    #heap_size,%d0          | d0 = end of heap
        movel   %d0,stack_start         | Save for brk() routine 
        addl    #stack_size,%d0         | make room for stack
        andl    #0xffffffc0,%d0         | align it on 16 byte boundary
        movw    #0x3700,%sr             | SUPV MODE,INTERRUPTS OFF!!!
        movel   %d0,%a7                 | set master stack pointer
        movel   %d0,%a6                 | set base pointer

        lea     hiintstack,%a0          | a0 = high end of intr stack
        movec   %a0,%isp                | set interrupt stack

        jsr     _HL_init                | initialize STDIO
        jsr     bsp_start 
        move.l  initial_isp,%a0
        movec   %a0,%isp
        move.l  initial_usp,%a0
        movec   %a0,%usp
        move.l  initial_msp,%a0
        movec   %a0,%msp
        move.w  initial_sr,%sr
        rts

END_CODE

BEGIN_DATA

PUBLIC_LABEL(start_frame)
        .space  4,0
PUBLIC_LABEL(stack_start)
        .space  4,0
END_DATA

BEGIN_BSS

PUBLIC_LABEL(initial_isp)
        .space  4

PUBLIC_LABEL(initial_msp)
        .space  4

PUBLIC_LABEL(initial_usp)
        .space  4

PUBLIC_LABEL(initial_sr)
        .space  2

        PUBLIC(heap_size)
        .set    heap_size,0x2000

        PUBLIC(stack_size)
        .set    stack_size,0x1000

END_DATA
END
