/*  Test_task2
 *
 *  This task attempts to receive control of a global semaphore.
 *  It should never receive control of the semaphore.
 *
 *  Input parameters:  
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

rtems_task Test_task2(
  rtems_task_argument argument
)
{
  rtems_status_code status;

  puts( "Getting SMID of semaphore" );
  status = semaphore_ident( 
    Semaphore_name[ 1 ], 
    SEARCH_ALL_NODES, 
    &Semaphore_id[ 1 ] 
  );
  directive_failed( status, "semaphore_ident" );

  puts( "Attempting to acquire semaphore ..." );
  status = semaphore_obtain( 
    Semaphore_id[ 1 ], 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );  
  directive_failed( status, "semaphore_obtain" );
}
