/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Event_task_id[ 2 ];       /* event task ids */

EXTERN rtems_id   Semaphore_task_id[ 2 ];   /* semaphore task ids */
EXTERN rtems_name Semaphore_task_name[ 2 ]; /* semaphore task names */

EXTERN rtems_id   Queue_task_id[ 3 ];       /* message queue task ids */
EXTERN rtems_name Queue_task_name[ 3 ];     /* message queue task names */

EXTERN rtems_id   Partition_task_id[ 1 ];   /* partition task ids */
EXTERN rtems_name Partition_task_name[ 4 ]; /* partition task names */

EXTERN rtems_id   Partition_id[ 3 ];    /* partition ids */
EXTERN rtems_name Partition_name[ 3 ];  /* partition names */

EXTERN rtems_id   Semaphore_id[ 3 ];    /* semaphore ids */
EXTERN rtems_name Semaphore_name[ 3 ];  /* semaphore names */

EXTERN rtems_id   Queue_id[ 3 ];        /* message queue ids */
EXTERN rtems_name Queue_name[ 3 ];      /* message queue names */

EXTERN rtems_id   Task_id[ 4 ];         /* remote event task ids */
EXTERN rtems_name Task_name[ 4 ];       /* remote event task names */

EXTERN rtems_unsigned32 Msg_buffer1[ 4 ];

extern rtems_multiprocessing_table Multiprocessing_configuration;

/* functions */

rtems_timer_service_routine Delayed_send_event(
  rtems_id  timer_id,
  void     *ignored
);

rtems_task Init(
  rtems_task_argument argument
);

rtems_task Test_task(
  rtems_task_argument argument
);

rtems_task Delayed_events_task(
  rtems_task_argument argument
);

rtems_task Message_queue_task(
  rtems_task_argument argument
);

rtems_task Partition_task(
  rtems_task_argument argument
);

rtems_task Semaphore_task(
  rtems_task_argument argument
);

/* end of include file */
