/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 4 ];     /* array of task ids */
EXTERN rtems_name Task_name[ 4 ];   /* array of task names */

extern rtems_multiprocessing_table Multiprocessing_configuration;

EXTERN rtems_unsigned32          remote_node;
EXTERN rtems_id                  remote_tid;
EXTERN rtems_signal_set          remote_signal;
EXTERN rtems_signal_set          expected_signal;
EXTERN volatile rtems_unsigned32 signal_count;
EXTERN volatile rtems_unsigned32 signal_caught;

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_asr Process_asr( rtems_signal_set );

rtems_task Test_task(
  rtems_task_argument argument
);

/* end of include file */
