/*  Init
 *
 *  This routine is the initialization task for this test program.
 *  It is called from init_exec and has the responsibility for creating
 *  and starting the tasks that make up the test.  If the time of day
 *  clock is required for the application, the current time might be 
 *  set by this task.
 *
 *  Input parameters:  NONE
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN 
#include "shm.h"
#include "conftbl.h"
#include "gvar.h"

int  Shm_statistics = 0;

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_name        task_name;
  rtems_id          tid;
  rtems_status_code status;

  printf( "\n\n*** SAMPLE MULTIPROCESSOR APPLICATION ***\n" );
  printf( "Creating and starting an application task\n" );
  task_name = build_name( 'T', 'A', '1', ' ' );
  status = task_create( task_name, 1, 1024, 
                        INTERRUPT_LEVEL(0), DEFAULT_ATTRIBUTES, &tid );
  status = task_start( tid, Application_task, Mp_conf_addr.node );
  status = task_delete( SELF );
}
