/*  Init
 *
 *  This routine is the initialization task for this test program.
 *  It is called from init_exec and has the responsibility for creating
 *  and starting the tasks that make up the test.  If the time of day
 *  clock is required for the test, it should also be set to a known
 *  value by this function.
 *
 *  Input parameters:  NONE
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN 
#include "conftbl.h"
#include "gvar.h"

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_status_code status;
  rtems_time_of_day time;

  puts( "\n\n*** CLOCK TICK TEST ***" );

  build_time( &time, 12, 31, 1988, 9, 0, 0, 0 );
  status = clock_set( &time );

  Task_name[ 1 ] = build_name( 'T', 'A', '1', ' ' );
  Task_name[ 2 ] = build_name( 'T', 'A', '2', ' ' );
  Task_name[ 3 ] = build_name( 'T', 'A', '3', ' ' );

  status = task_create( Task_name[ 1 ], 1, 1024, DEFAULT_MODES, 
                        DEFAULT_ATTRIBUTES, &Task_id[ 1 ] );
  status = task_create( Task_name[ 2 ], 1, 1024, DEFAULT_MODES, 
                        DEFAULT_ATTRIBUTES, &Task_id[ 2 ] );
  status = task_create( Task_name[ 3 ], 1, 1024, DEFAULT_MODES, 
                        DEFAULT_ATTRIBUTES, &Task_id[ 3 ] );

  status = task_start( Task_id[ 1 ], Test_task, 1 );
  status = task_start( Task_id[ 2 ], Test_task, 2 );
  status = task_start( Task_id[ 3 ], Test_task, 3 );

  status = task_delete( SELF );
}
