/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 4 ];      /* array of task ids */
EXTERN rtems_name Task_name[ 4 ];    /* array of task names */

EXTERN rtems_id   Timer_id[ 7 ];     /* array of timer ids */
EXTERN rtems_name Timer_name[ 7 ];   /* array of timer names */

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Task_2(
  rtems_task_argument argument
);

rtems_timer_service_routine TA1_send_18_to_self_5_seconds(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA1_send_8_to_self_60_seconds(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA1_send_9_to_self_60_seconds(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA1_send_10_to_self(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA1_send_1_to_self_every_second(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA1_send_11_to_self(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_timer_service_routine TA2_send_10_to_self(
  rtems_id  ignored1,
  void     *ignored2
);

/* end of include file */
