/*  Task_2
 *
 *  This routine serves as a test task.  It simply obtains semaphores
 *  1 and 2, the later when it is a high priority task.
 *
 *  Input parameters:  
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */


#include "system.h"

rtems_task Task_2(
  rtems_task_argument argument
)
{
  rtems_status_code   status;
  rtems_task_priority previous_priority;

  puts( "TA2 - semaphore_obtain - wait forever on SM1" );
  status = semaphore_obtain( 
    Semaphore_id[ 1 ], 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );
  puts( "TA2 - got SM1" );
  directive_failed( status, "semaphore_obtain on SM1" );

  puts( "TA2 - semaphore_release - release SM1" );
  status = semaphore_release( Semaphore_id[ 1 ] );
  directive_failed( status, "semaphore_release on SM1" );

  puts( "TA2 - task_set_priority - make self highest priority task" );
  status = task_set_priority( SELF, 3, &previous_priority );
  directive_failed( status, "task_set_priority on TA2" );

  puts( "TA2 - semaphore_obtain - wait forever on SM2" );
  status = semaphore_obtain(
    Semaphore_id[ 2 ], 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );
  puts( "TA2 - got SM2" );
  directive_failed( status, "semaphore_obtain on SM2" );

  puts( "TA2 - semaphore_release - release SM2" );
  status = semaphore_release( Semaphore_id[ 2 ] );
  directive_failed( status, "semaphore_release on SM2" );

  puts( "TA2 - task_delete - delete self" );
  status = task_delete( SELF );
  directive_failed( status, "task_delete of TA2" );
}
