/*  Task_3
 *
 *  This routine serves as a test task.  Its major function is to
 *  broadcast a messge to all the other tasks.
 *
 *  Input parameters:  
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

rtems_task Task_3(
  rtems_task_argument argument
)
{
  long              buffer[ 4 ];
  rtems_unsigned32  count;
  rtems_status_code status;

  puts( 
    "TA3 - message_queue_receive - receive from queue 2 - WAIT FOREVER"
  );
  status = message_queue_receive( 
    Queue_id[ 2 ], 
    (long (*)[4])buffer, 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );
  directive_failed( status, "message_queue_receive" );
  puts_nocr( "TA3 - buffer received: " );
  Put_buffer( buffer );
  new_line;

  Fill_buffer( "BUFFER 3 TO Q 1", (long *)buffer );
  puts( "TA3 - message_queue_broadcast - BUFFER 3 TO Q 1" );
  status = message_queue_broadcast( 
    Queue_id[ 1 ], 
    (long (*)[4])buffer, 
    &count 
  );
  printf( "TA3 - number of tasks awakened = %02d\n", count );
  puts( 
    "TA3 - message_queue_receive - receive from queue 3 - WAIT FOREVER" 
  );

  status = message_queue_receive( 
    Queue_id[ 3 ], 
    (long (*)[4])buffer, 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );
  directive_failed( status, "message_queue_receive" );
  puts_nocr( "TA3 - buffer received: " );
  Put_buffer( buffer );
  new_line;

  puts( "TA3 - task_delete - delete self" );
  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}
