/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 3 ];       /* array of task ids */
EXTERN rtems_name Task_name[ 3 ];     /* array of task names */

EXTERN rtems_id   Timer_id[ 3 ];      /* array of timer ids */
EXTERN rtems_name Timer_name[ 3 ];    /* array of timer names */

EXTERN volatile rtems_unsigned32 Signals_sent;
                                      /* set to TRUE to indicate that a */
                                      /* signal set has been sent from  */
                                      /* an ISR to the executing task   */

EXTERN volatile rtems_unsigned32 Asr_fired;
                                      /* set to TRUE to indicate that the */
                                      /* ASR has executed and was passed  */
                                      /* the correct signal set           */

EXTERN volatile rtems_id  Timer_got_this_id;

EXTERN volatile void     *Timer_got_this_ptr;

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_timer_service_routine Signal_3_to_task_1(
  rtems_id  id,
  void     *ptr
);

rtems_asr Process_asr( 
  rtems_signal_set the_signal_set
);

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Task_2(
  rtems_task_argument argument
);


/* end of include file */
