/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 6 ];      /* array of task ids */
EXTERN rtems_name Task_name[ 6 ];    /* array of task names */
EXTERN rtems_id   Region_id[ 4 ];    /* array of region ids */
EXTERN rtems_name Region_name[ 4 ];  /* array of region names */

EXTERN rtems_unsigned8 Area_1[4096];
EXTERN rtems_unsigned8 Area_2[4096];
EXTERN rtems_unsigned8 Area_3[4096];

#define BASE_PRIORITY 140

#define Put_address_from_area_1( _to_be_printed ) \
   printf( "0x%08x", ((rtems_unsigned8 *)(_to_be_printed)) - Area_1 )

#define Put_address_from_area_2( _to_be_printed ) \
   printf( "0x%08x", ((rtems_unsigned8 *)(_to_be_printed)) - Area_2 )

#define Put_address_from_area_3( _to_be_printed ) \
   printf( "0x%08x", ((rtems_unsigned8 *)(_to_be_printed)) - Area_3 )


/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Task_2(
  rtems_task_argument argument
);

rtems_task Task_3(
  rtems_task_argument argument
);

rtems_task Task_4(
  rtems_task_argument argument
);

rtems_task Task5(
  rtems_task_argument argument
);

/* end of include file */
