/*  First_FP_task
 *
 *  This routine serves as a floating point test task.  It verifies the 
 *  basic task switching capabilities of the executive when floating 
 *  point is configured.
 *
 *  Input parameters:  
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

rtems_task First_FP_task(
  rtems_task_argument argument
)
{
  rtems_status_code status;
  rtems_id          tid;
  rtems_time_of_day time;

  status = task_ident( SELF, SEARCH_ALL_NODES, &tid );
  directive_failed( status, "task_ident" );

  FP_load( FP_context[ task_number( tid ) - 3 ] );

  if ( argument == 0 ) {
    status = task_restart( SELF, 1 );
    directive_failed( status, "task_restart of SELF" );
  } else {
    build_time( &time, 12, 31, 1988, 9, 0, 0, 0 );
    status = clock_set( &time );
    directive_failed( status, "clock_set" );

    status = task_delete( SELF );
    directive_failed( status, "task_delete of SELF" );
  }
}
