/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 4 ];     /* array of task ids */
EXTERN rtems_name Task_name[ 4 ];   /* array of task names */

extern rtems_initialization_tasks_table Initialization_tasks[];
extern rtems_extensions_table           Extensions;
extern rtems_configuration_table        Configuration;
extern rtems_cpu_table                  Cpu_table;

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

void put_error(
  rtems_unsigned32  error,
  rtems_status_code expected
);

rtems_extension Workspace_of_zero_fatal_extension( 
  rtems_unsigned32 error
);

rtems_extension Null_workspace_fatal_extension( 
  rtems_unsigned32 error
);

rtems_extension Workspace_too_small_fatal_extension( 
  rtems_unsigned32 error
);

rtems_extension Init_task_create_fatal_extension( 
  rtems_unsigned32 error
);

rtems_extension Init_task_start_fatal_extension( 
  rtems_unsigned32 error
);

rtems_extension Final_fatal_extension( 
  rtems_unsigned32 error
);

rtems_task Task_1(
  rtems_task_argument argument
);

/* end of include file */
