/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 5 ];     /* array of task ids */
EXTERN rtems_name Task_name[ 5 ];   /* array of task names */

extern rtems_configuration_table Configuration;
                                    /* init.c includes init'ed one */

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Task_2(
  rtems_task_argument argument
);

rtems_task Task_3(
  rtems_task_argument argument
);

rtems_task Task_4(
  rtems_task_argument argument
);


rtems_extension Task_create_extension( 
  rtems_tcb *unused, 
  rtems_tcb *created_task 
);

rtems_extension Task_delete_extension( 
  rtems_tcb *running_task, 
  rtems_tcb *deleted_task
);

rtems_extension Task_restart_extension( 
  rtems_tcb *unused, 
  rtems_tcb *restarted_task
);

rtems_extension Task_start_extension( 
  rtems_tcb *unused, 
  rtems_tcb *started_task 
);

rtems_extension Task_exit_extension( 
  rtems_tcb *running_task 
);

/* end of include file */
