/*  gvar.h  
 *
 *  This header file contains the global variables for the test set.
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

EXTERN rtems_id   Task_id[ 10 ];       /* array of task ids */
EXTERN rtems_name Task_name[ 10 ];     /* array of task names */

EXTERN rtems_name Timer_name[ 2 ];     /* array of timer names */
EXTERN rtems_id   Timer_id[ 2 ];       /* array of timer ids */

EXTERN rtems_name Semaphore_name[ 4 ]; /* array of semaphore names */
EXTERN rtems_id   Semaphore_id[ 4 ];   /* array of semaphore ids */

EXTERN rtems_name Queue_name[ 3 ];     /* array of queue names */
EXTERN rtems_id   Queue_id[ 3 ];       /* array of queue ids */

EXTERN rtems_name Partition_name[ 2 ]; /* array of partition names */
EXTERN rtems_id   Partition_id[ 2 ];   /* array of partition ids */

EXTERN rtems_name Region_name[ 2 ];    /* array of region names */
EXTERN rtems_id   Region_id[ 2 ];      /* array of region ids */

EXTERN rtems_name Port_name[ 2 ];      /* array of port names */
EXTERN rtems_id   Port_id[ 2 ];        /* array of port ids */

EXTERN rtems_name Period_name[ 2 ];    /* array of period names */
EXTERN rtems_id   Period_id[ 2 ];      /* array of period ids */

EXTERN rtems_id   Junk_id;             /* id used to return errors */

#define Internal_port_area (void *) 0x00001000
#define External_port_area (void *) 0x00002000

EXTERN rtems_unsigned8 Partition_good_area[256];
#define Partition_bad_area (void *) 0x00000006

EXTERN rtems_unsigned32 Region_good_area[128];
#define Region_bad_area    (void *) 0x00000006

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

rtems_timer_service_routine Delayed_routine(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Task_2(
  rtems_task_argument argument
);

rtems_task Task_3(
  rtems_task_argument argument
);

rtems_task Task_4(
  rtems_task_argument argument
);

rtems_isr Service_routine(
  rtems_vector_number ignored
);

rtems_timer_service_routine Io_during_interrupt(
  rtems_id ignored
);

void Screen1( void );

void Screen2( void );

void Screen3( void );

void Screen4( void );

void Screen5( void );

void Screen6( void );

void Screen7( void );

void Screen8( void );

void Screen9( void );

void Screen10( void );

void Screen11( void );

void Screen12( void );

void Screen13( void );

void Screen14( void );

/* end of include file */
