/*  Screen8
 *
 *  This routine generates error screen 8 for test 9.
 *
 *  Input parameters:  NONE
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

void Screen8()
{
  long              buffer[ 4 ];
  rtems_status_code status;

  status = message_queue_delete( Queue_id[ 1 ] );
  directive_failed( status, "message_queue_delete successful" );
  puts( "TA1 - message_queue_delete - Q 1 - SUCCESSFUL" );

  status = message_queue_create( 
    Queue_name[ 1 ], 
    2, 
    LIMIT, 
    &Queue_id[ 1 ] 
  );
  directive_failed( status, "message_queue_create successful" );
  puts( "TA1 - message_queue_create - Q 1 - LIMIT - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  directive_failed( status, "message_queue_send successful" );
  puts( "TA1 - message_queue_send - BUFFER 1 TO Q 1 - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  directive_failed( status, "message_queue_send successful" );
  puts( "TA1 - message_queue_send - BUFFER 2 TO Q 1 - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  fatal_directive_status( 
    status,
    TOO_MANY,
    "message_queue_send too many to limited queue"
  );
  puts( "TA1 - message_queue_send - BUFFER 3 TO Q 1 - TOO_MANY" );

  status = message_queue_delete( Queue_id[ 1 ] );
  directive_failed( status, "message_queue_delete successful" );
  puts( "TA1 - message_queue_delete - Q 1 - SUCCESSFUL" );

  status = message_queue_create( 
    Queue_name[ 1 ], 
    3, 
    LIMIT, 
    &Queue_id[ 1 ] 
  );
  directive_failed( status, "message_queue_create successful" );
  puts( "TA1 - message_queue_create - Q 1 - LIMIT - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  directive_failed( status, "message_queue_send successful" );
  puts( "TA1 - message_queue_send - BUFFER 1 TO Q 1 - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  directive_failed( status, "message_queue_send successful" );
  puts( "TA1 - message_queue_send - BUFFER 2 TO Q 1 - SUCCESSFUL" );

  status = message_queue_send( Queue_id[ 1 ], (long (*)[4])buffer );
  fatal_directive_status( 
    status,
    UNSATISFIED,
    "message_queue_send too many to limited queue"
  );
  puts( "TA1 - message_queue_send - BUFFER 3 TO Q 1 - UNSATISFIED" );

  status = message_queue_delete( Queue_id[ 1 ] );
  directive_failed( status, "message_queue_delete successful" );
  puts( "TA1 - message_queue_delete - Q 1 - SUCCESSFUL" );

  status = message_queue_create( 
    Queue_name[ 1 ], 
    3, 
    LIMIT, 
    &Queue_id[ 1 ] 
  );
  directive_failed( status, "message_queue_create successful" );
  puts( "TA1 - message_queue_create - Q 1 - LIMIT - SUCCESSFUL" );

  puts( "TA1 - task_start - start TA3 - SUCCESSFUL" );
  status = task_start( Task_id[ 3 ], Task_3, 0 );
  directive_failed( status, "task_start of TA3" );

  puts( "TA1 - task_wake_after - yield processor - SUCCESSFUL" );
  status = task_wake_after( YIELD_PROCESSOR );
  directive_failed( status, "task_wake_after (yield)" );

  puts( "TA1 - message_queue_delete - delete Q 1 - SUCCESSFUL" );
  status = message_queue_delete( Queue_id[ 1 ] );
  directive_failed( status, "message_queue_delete successful" );

  puts( "TA1 - task_wake_after - yield processor - SUCCESSFUL" );
  status = task_wake_after( YIELD_PROCESSOR );
  directive_failed( status, "task_wake_after (yield)" );
}
