/*  Screen9
 *
 *  This routine generates error screen 9 for test 9.
 *
 *  Input parameters:  NONE
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

void Screen9()
{
  void              *converted;
  rtems_status_code status;
  rtems_isr_entry   old_service_routine;

  status = interrupt_catch( Service_routine, 500, &old_service_routine );
  fatal_directive_status( 
    status,
    INVALID_NUMBER,
    "interrupt_catch with invalid vector"
  );
  puts( "TA1 - interrupt_catch - INVALID_NUMBER" );
  
  status = interrupt_catch( NULL, 3, &old_service_routine );
  fatal_directive_status( 
    status,
    INVALID_ADDRESS,
    "interrupt_catch with invalid handler"
  );
  puts( "TA1 - interrupt_catch - INVALID_ADDRESS" );
  
  status = signal_send( 100, SIGNAL_1 );
  fatal_directive_status( 
    status,
    INVALID_ID,
    "signal_send with illegal id"
  );
  puts( "TA1 - signal_send - INVALID_ID" );

  status = signal_send( SELF, SIGNAL_16 );
  fatal_directive_status( 
    status,
    NOT_DEFINED,
    "signal_send with no handler"
  );
  puts( "TA1 - signal_send - NOT_DEFINED" );

  status = port_create( 
     0, 
     Internal_port_area,
     External_port_area,
     sizeof( Internal_port_area ),
     &Junk_id
  );
  fatal_directive_status( 
    status,
    INVALID_NAME,
    "port_create with illegal name"
  );
  puts( "TA1 - port_create - INVALID_NAME" );

  status = port_create( 
     Port_name[ 1 ], 
     &((char *)Internal_port_area)[ 1 ],
     External_port_area,
     sizeof( Internal_port_area ),
     &Junk_id
  );
  fatal_directive_status( 
    status,
    INVALID_ADDRESS,
    "port_create with illegal address"
  );
  puts( "TA1 - port_create - INVALID_ADDRESS" );

  status = port_create( 
     Port_name[ 1 ], 
     Internal_port_area,
     External_port_area,
     sizeof( Internal_port_area ),
     &Junk_id
  );
  fatal_directive_status( 
    status,
    TOO_MANY,
    "port_create of too many"
  );
  puts( "TA1 - port_create - TOO_MANY" );

  status = port_delete( 0 );
  fatal_directive_status( 
    status,
    INVALID_ID,
    "port_delete with illegal id"
  );
  puts( "TA1 - port_delete - INVALID_ID" );

  status = port_ident( 0, &Junk_id );
  fatal_directive_status( 
    status,
    INVALID_NAME,
    "port_ident with illegal name"
  );
  puts( "TA1 - port_ident - INVALID_NAME" );

  status = port_external_to_internal( 
    100, 
    Internal_port_area,
    &converted 
  );
  fatal_directive_status( 
    status,
    INVALID_ID,
    "port_external_to_internal with illegal id"
  );
  puts( "TA1 - port_external_to_internal - INVALID_ID" );
  status = port_internal_to_external( 
    100, 
    Internal_port_area,
    &converted 
  );
  fatal_directive_status( 
    status,
    INVALID_ID,
    "port_internal_to_external with illegal id"
  );
  puts( "TA1 - port_internal_to_external - INVALID_ID" );
}
