/*  Task_2
 *
 *  This routine serves as a test task.  Its only purpose is to generate the
 *  error where a semaphore is deleted while a task is waiting for it.
 *
 *  Input parameters:  
 *    argument - task argument
 *
 *  Output parameters:  NONE
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"

rtems_task Task_2(
  rtems_task_argument argument
)
{
  rtems_status_code status;

  puts( "TA2 - semaphore_obtain - sem 1 - WAIT FOREVER" );
  status = semaphore_obtain( 
    Semaphore_id[ 1 ], 
    DEFAULT_OPTIONS, 
    NO_TIMEOUT 
  );
  fatal_directive_status( 
    status, 
    OBJECT_WAS_DELETED,
    "semaphore_obtain waiting to be deleted"
  );
  puts( "TA2 - semaphore_obtain - woke up with OBJECT_WAS_DELETED" );

  puts( "TA2 - task_delete - delete self - SUCCESSFUL" );
  status = task_delete( SELF );
  directive_failed( status, "task_delete of TA2" );
}
