/*  getint
 *
 *  This routine returns a positive integer and ignores all 
 *  non-numeric input.  It assumes decimal.
 *
 *  Input parameters:   NONE
 *
 *  Output parameters:
 *    returns - key pressed
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "rtems.h"
#include "block_io.h"
#include "iosupp.h"

int getint()
{
  int c, num; 

  num = 0;
  while ( TRUE ) {
     console( CONSOLE_INPUT, (int) &c );
     console( CONSOLE_OUTPUT, c );
     switch( c ) {
       case CR:
       case LF:  
         console( CONSOLE_OUTPUT, '\n' );
         return num;
       case BS: 
         console( CONSOLE_OUTPUT, ' ' );
         console( CONSOLE_OUTPUT, c );
         if ( num != 0 )
           num /= 10;
         break;
       case '0': case '1': case '2': case '3':
       case '4': case '5': case '6': case '7':
       case '8': case '9':
         num = (num * 10) + (c - 0x30);
         break;
     }
  }
}
