/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_id Queue_id;

long Buffer[4];

rtems_task test_init(
  rtems_task_argument argument
);
 
rtems_task High_task(
  rtems_task_argument argument
);
 
rtems_task Low_tasks(
  rtems_task_argument argument
);

 
rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_id          task_id;
  rtems_status_code status;

  puts( "\n\n*** TIME TEST 14 ***" );

  status = task_create( 
    1, 
    251, 
    1024, 
    DEFAULT_MODES, 
    DEFAULT_ATTRIBUTES, 
    &task_id 
  );
  directive_failed( status, "task_create" );

  status = task_start( task_id, test_init, 0 );
  directive_failed( status, "task_start" );

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

rtems_task test_init(
  rtems_task_argument argument
)
{
  rtems_unsigned32     index;
  rtems_task_entry     task_entry;
  rtems_task_priority  priority;
  rtems_id             task_id;  
  rtems_status_code    status;


  status = message_queue_create( 
    build_name( 'M', 'Q', '1', ' ' ), 
    OPERATION_COUNT, 
    DEFAULT_ATTRIBUTES, 
    &Queue_id 
  );
  directive_failed( status, "message_queue_create" );
 
  priority = 250;

  for( index = 0; index <= OPERATION_COUNT ; index++ ) {
    status = task_create( 
      build_name( 'T', 'I', 'M', 'E' ),
      priority, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &task_id 
    );
    directive_failed( status, "task_create LOOP" );

    priority--;

    if ( index==OPERATION_COUNT ) task_entry = High_task;
    else                          task_entry = Low_tasks;

    status = task_start( task_id, task_entry, 0 );
    directive_failed( status, "task_start LOOP" );
  }
}

rtems_task High_task(
  rtems_task_argument argument
) 
{
  rtems_unsigned32  index;

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) Empty_function();
  overhead = Read_timer();

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) message_queue_urgent( Queue_id, (long (*)[4]) Buffer );
  end_time = Read_timer();

  put_time(
    "MESSAGE_QUEUE_URGENT (readying)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_MESSAGE_QUEUE_URGENT
  );

  exit( 0 );
}

rtems_task Low_tasks(
  rtems_task_argument argument
)
{
  (void) message_queue_receive(
           Queue_id, 
           (long (*)[4]) Buffer, 
           DEFAULT_OPTIONS, 
           NO_TIMEOUT
         );
}
