/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_unsigned32 taskcount;
rtems_task_priority taskpri;

rtems_task First_task(
  rtems_task_argument argument
);

rtems_task Middle_tasks(
  rtems_task_argument argument
);

rtems_task Last_task(
  rtems_task_argument argument
);


void test_init();

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_status_code status;

  puts( "\n\n*** TIME TEST 18 ***" );

  test_init();

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

void test_init()
{ 
  rtems_id          id;
  rtems_task_entry  task_entry;
  rtems_unsigned32  index;
  rtems_status_code status;

  for ( index = 0 ; index <= OPERATION_COUNT ; index++ ) {
    status = task_create( 
      build_name( 'T', 'I', 'M', 'E' ),
      128, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "task_create loop" );

    if ( index == OPERATION_COUNT ) task_entry = Last_task;
    else if ( index == 0 )          task_entry = First_task;
    else                            task_entry = Middle_tasks;

    
    status = task_start( id, task_entry, 0 );
    directive_failed( status, "task_start loop" );
  }

}

rtems_task First_task(
  rtems_task_argument argument
)
{
  Timer_initialize();

  (void) task_delete( SELF );
}

rtems_task Middle_tasks(
  rtems_task_argument argument
)
{
  (void) task_delete( SELF );
}

rtems_task Last_task(
  rtems_task_argument argument
)
{
  end_time = Read_timer(); 

  put_time(
    "TASK_DELETE self",
    end_time,
    OPERATION_COUNT,
    0,
    CALLING_OVERHEAD_TASK_DELETE
  );

  exit( 0 );
}
