/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_unsigned8 Region_area[ 2048 ];
rtems_unsigned8 Partition_area[ 2048 ];

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_id          id;
  rtems_status_code status;

  puts( "\n\n*** TIME TEST 21 ***" );

  status = task_create( 
    build_name( 'T', 'I', 'M', 'E' ),
    250, 
    1024, 
    DEFAULT_MODES, 
    DEFAULT_ATTRIBUTES, 
    &id 
  );
  directive_failed( status, "task_create of TASK1" );

  status = task_start( id, Task_1, 0 );
  directive_failed( status, "task_start of TASK1" );

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

rtems_task Task_1(
  rtems_task_argument argument
)
{ 
  rtems_unsigned32  index;
  rtems_id          id;
  rtems_status_code status;

  for( index = 1 ; index <= OPERATION_COUNT ; index++ ) {
    status = task_create ( 
      index, 
      254, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "task_create" );

    status = message_queue_create( 
      index, 
      OPERATION_COUNT, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "message_queue_create" );

    status = semaphore_create( 
      index, 
      OPERATION_COUNT, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "semaphore_create" );

    status = region_create( 
      index, 
      Region_area,
      2048, 
      16, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "region_create" );

    status = partition_create( 
      index, 
      Partition_area,
      2048, 
      128, 
      DEFAULT_ATTRIBUTES, 
      &id
    );
    directive_failed( status, "partition_create" );

    status = port_create( 
      index, 
      Partition_area,
      Region_area,
      0xff, 
      &id 
    );
    directive_failed( status, "port_create" );

    status = timer_create( index, &id );
    directive_failed( status, "timer_create" );

    status = rate_monotonic_create( index, &id );
    directive_failed( status, "rate_monotonic_create" );
  }

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) Empty_function();
  overhead = Read_timer();

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) task_ident( index, SEARCH_ALL_NODES, &id );
  end_time = Read_timer();

  put_time(
    "TASK_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TASK_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) message_queue_ident( index, SEARCH_ALL_NODES, &id );
  end_time = Read_timer();

  put_time(
    "MESSAGE_QUEUE_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_MESSAGE_QUEUE_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) semaphore_ident( index, SEARCH_ALL_NODES, &id );
  end_time = Read_timer();

  put_time(
    "SEMAPHORE_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_SEMAPHORE_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) partition_ident( index, SEARCH_ALL_NODES, &id );
  end_time = Read_timer();

  put_time(
    "PARTITION_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_PARTITION_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) region_ident( index, &id );
  end_time = Read_timer();

  put_time(
    "REGION_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_REGION_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) port_ident( index, &id );
  end_time = Read_timer();

  put_time(
    "PORT_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_PORT_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_ident( index, &id );
  end_time = Read_timer();

  put_time(
    "TIMER_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_IDENT
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) rate_monotonic_ident( index, &id );
  end_time = Read_timer();

  put_time(
    "RATE_MONOTONIC_IDENT",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_RATE_MONOTONIC_IDENT
  );

  exit( 0 );
}
