/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_id          Timer_id[ OPERATION_COUNT+1 ];

rtems_time_of_day time;

void null_delay(
  rtems_id  ignored1,
  void     *ignored2
);

rtems_task Low_task(
  rtems_task_argument argument
);
 
rtems_task Middle_tasks(
  rtems_task_argument argument
);
 
rtems_task High_task(
  rtems_task_argument argument
);

 
rtems_task Init(
  rtems_task_argument argument
)
{ 

  rtems_task_priority priority;
  rtems_unsigned32    index;
  rtems_id            id;
  rtems_task_entry    task_entry;
  rtems_status_code   status;

  puts( "\n\n*** TIME TEST 23 ***" );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) Empty_function();
  overhead = Read_timer();

  priority = 5;

  for( index=1 ; index <= OPERATION_COUNT ; index++ ) {
    status = task_create( 
      build_name( 'T', 'I', 'M', 'E' ),
      priority, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "task_create LOOP" );

    if ( index == 1 )                    task_entry = High_task;
    else if ( index == OPERATION_COUNT ) task_entry = Low_task;
    else                                 task_entry = Middle_tasks;

    status = task_start( id, task_entry, 0 );
    directive_failed( status, "task_start LOOP" );

    priority++;
  }

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

void null_delay(
  rtems_id  ignored1,
  void     *ignored2
) 
{
}

rtems_task High_task(
  rtems_task_argument argument
) 
{ 
  rtems_unsigned32  index;
  rtems_status_code status;
  int i; 

  printf("TM_EVAFTER (old) na\n" );
  printf("TM_DELETE (old) na\n" );
  printf("TM_EVWHEN (old) na\n" );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) Empty_function();
  overhead = Read_timer();

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_create( index, &Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_CREATE",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_CREATE
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_fire_after( Timer_id[ index ], 500, null_delay, NULL );
  end_time = Read_timer();

  put_time(
    "TIMER_FIRE_AFTER (inactive)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_FIRE_AFTER
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_fire_after( Timer_id[ index ], 500, null_delay, NULL );
  end_time = Read_timer();

  put_time(
    "TIMER_FIRE_AFTER (active)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_FIRE_AFTER
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_cancel( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_CANCEL (active)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_CANCEL
  );

  for ( Timer_initialize(), i=0 ; i<OPERATION_COUNT ; i++ )
  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_cancel( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_CANCEL (inactive)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_CANCEL
  );
  
  for ( Timer_initialize(), i=0 ; i<OPERATION_COUNT ; i++ )
  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_reset( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_RESET (inactive)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_RESET
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_reset( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_RESET (active)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_RESET
  );

  for ( index=1 ; index <= OPERATION_COUNT ; index++ )
    (void) timer_reset( Timer_id[ index ] );
  
  build_time( &time, 12, 31, 1988, 9, 0, 0, 0 );

  status = clock_set( &time );
  directive_failed( status, "clock_set" );

  time.year = 1989;
  
  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_fire_when( Timer_id[ index ], &time, null_delay, NULL );
  end_time = Read_timer();

  put_time(
    "TIMER_FIRE_WHEN (inactive)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_FIRE_WHEN
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_fire_when( Timer_id[ index ], &time, null_delay, NULL );
  end_time = Read_timer();

  put_time(
    "TIMER_FIRE_WHEN (active)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_FIRE_WHEN
  );

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_delete( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_DELETE (active)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_DELETE
  );

  Timer_initialize();
  for ( index=1 ; index <= OPERATION_COUNT ; index++ ) {
    status = timer_create( index, &Timer_id[ index ] );
    directive_failed( status, "timer_create" );

    status = timer_fire_after( Timer_id[ index ], 500, null_delay, NULL );
    directive_failed( status, "timer_fire_after" );

    status = timer_cancel( Timer_id[ index ] );
    directive_failed( status, "timer_cancel" );
  }

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) timer_delete( Timer_id[ index ] );
  end_time = Read_timer();

  put_time(
    "TIMER_DELETE (inactive)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TIMER_DELETE
  );

  Timer_initialize();
    (void) task_wake_when( &time );
}

rtems_task Middle_tasks(
  rtems_task_argument argument
) 
{ 
  (void) task_wake_when( &time );
}

rtems_task Low_task(
  rtems_task_argument argument
) 
{ 
  end_time = Read_timer();

  put_time(
    "TASK_WAKE_WHEN",
    end_time,
    OPERATION_COUNT,
    0,
    CALLING_OVERHEAD_TASK_WAKE_WHEN
  );

  printf( "TM_EVEVERY (old) na\n" );
  exit( 0 );
}
