/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_unsigned32 Task_count;

rtems_task Tasks(
  rtems_task_argument argument
);

rtems_task High_task(
  rtems_task_argument argument
);

rtems_task Init(
  rtems_task_argument argument
)
{
  rtems_id          id;
  rtems_unsigned32  index;
  rtems_status_code status;

  puts( "\n\n*** TIME TEST 24 ***" );

  status = task_create( 
    build_name( 'H', 'I', 'G', 'H' ),
    10, 
    1024, 
    DEFAULT_MODES, 
    DEFAULT_ATTRIBUTES, 
    &id 
  );
  directive_failed( status, "task_create HIGH" );

  status = task_start( id, High_task, 0 );
  directive_failed( status, "task_create HIGH" );

  for ( index = 1 ; index <= OPERATION_COUNT ; index++ ) {
    status = task_create( 
      build_name( 'R', 'E', 'S', 'T' ),
      128, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &id 
    );
    directive_failed( status, "task_create LOOP" );

    status = task_start( id, Tasks, 0 );
    directive_failed( status, "task_start LOOP" );
  }
  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

rtems_task High_task(
  rtems_task_argument argument
)
{ 
  rtems_status_code status;
  rtems_unsigned32  index;

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) Empty_function();
  overhead = Read_timer();

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) task_wake_after( YIELD_PROCESSOR );
  end_time = Read_timer();

  put_time(
    "TASK_WAKE_AFTER (no context switch)",
    end_time,
    OPERATION_COUNT,
    overhead,
    CALLING_OVERHEAD_TASK_WAKE_AFTER
  );

  Task_count = 0;

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

rtems_task Tasks(
  rtems_task_argument argument
) 
{
  Task_count++;

  if ( Task_count == 1 ) 
    Timer_initialize();
  else if ( Task_count == OPERATION_COUNT ) {
    end_time = Read_timer();

    put_time(
      "TASK_WAKE_AFTER (context switch)",
      end_time,
      OPERATION_COUNT,
      overhead,
      CALLING_OVERHEAD_TASK_WAKE_AFTER
    );

    exit( 0 );
  }
  (void) task_wake_after( YIELD_PROCESSOR );
}
