/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_id Semaphore_id;

rtems_task High_tasks(
  rtems_task_argument argument
);
 
rtems_task Low_task(
  rtems_task_argument argument
);

rtems_task Init(
  rtems_task_argument argument
)
{ 
  rtems_id          task_id;
  rtems_unsigned32  index;
  rtems_status_code status;

  puts( "\n\n*** TIME TEST 25 ***" );

  status = semaphore_create( 
    build_name( 'S', 'M', '1', ' ') , 
    0, 
    DEFAULT_ATTRIBUTES, 
    &Semaphore_id
  );
  directive_failed( status, "semaphore_create of SM1" );

  status = task_create( 
    build_name( 'L', 'O', 'W', ' ' ),
    254, 
    1024, 
    DEFAULT_MODES, 
    DEFAULT_ATTRIBUTES, 
    &task_id 
  );
  directive_failed( status, "task_create LOW" );

  status = task_start( task_id, Low_task, 0 );
  directive_failed( status, "task_start LOW" );

  for ( index=1 ; index <= OPERATION_COUNT ; index++ ) {
    status = task_create( 
      build_name( 'T', 'I', 'M', 'E' ),
      128, 
      1024, 
      DEFAULT_MODES, 
      DEFAULT_ATTRIBUTES, 
      &task_id 
    );
    directive_failed( status, "task_create LOOP" );

    status = task_start( task_id, High_tasks, 0 );
    directive_failed( status, "task_start LOOP" );
  }

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

rtems_task High_tasks(
  rtems_task_argument argument
) 
{ 
  (void) semaphore_obtain(Semaphore_id, DEFAULT_OPTIONS, 0xffffffff);
}

rtems_task Low_task(
  rtems_task_argument argument
)
{ 
  Timer_initialize();
    (void) clock_tick();
  end_time = Read_timer();

  put_time(
    "CLOCK_TICK",
    end_time,
    1,
    0,
    CALLING_OVERHEAD_CLOCK_TICK
  );

  exit( 0 );
}
