/*  dumrtems.h
 *
 *  This include file contains phony macros to map
 *  executive calls to Empty_directive().
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#ifndef __DUMRTEMS_h
#define __DUMRTEMS_h

/* RTEMS call redefinition macros */

#undef signal_catch
#undef signal_send
#undef io_close
#undef io_control
#undef io_initialize
#undef io_open
#undef io_read
#undef io_write
#undef port_internal_to_external
#undef port_external_to_internal
#undef port_create
#undef port_delete
#undef port_ident
#undef event_receive
#undef event_send
#undef initialize_executive
#undef shutdown_executive
#undef interrupt_catch
#undef partition_create
#undef partition_delete
#undef partition_get_buffer
#undef partition_ident
#undef partition_return_buffer
#undef message_queue_broadcast
#undef message_queue_create
#undef message_queue_delete
#undef message_queue_flush
#undef message_queue_ident
#undef message_queue_receive
#undef message_queue_send
#undef message_queue_urgent
#undef region_create
#undef region_delete
#undef region_get_segment
#undef region_ident
#undef region_return_segment
#undef semaphore_create
#undef semaphore_delete
#undef semaphore_ident
#undef semaphore_obtain
#undef semaphore_release
#undef task_create
#undef task_delete
#undef task_get_note
#undef task_ident
#undef task_mode
#undef task_restart
#undef task_resume
#undef task_set_note
#undef task_set_priority
#undef task_start
#undef task_suspend
#undef clock_get
#undef clock_set
#undef clock_tick
#undef task_wake_after
#undef task_wake_when
#undef fatal_error_occurred
#undef rate_monotonic_create
#undef rate_monotonic_ident
#undef rate_monotonic_delete
#undef rate_monotonic_cancel
#undef rate_monotonic_period
#undef multiprocessing_announce
#undef timer_create
#undef timer_ident
#undef timer_delete
#undef timer_cancel
#undef timer_fire_after
#undef timer_fire_when
#undef timer_reset

#define     signal_catch( asraddr, mode ) \
           Empty_directive( asraddr, mode ) 
#define     signal_send( tid, signal ) \
           Empty_directive( tid, signal )

#define     io_close( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )
#define     io_control( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )
#define     io_initialize( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )
#define     io_open( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )
#define     io_read( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )
#define     io_write( major, minor, argp, rval ) \
           Empty_directive( major, minor, argp, rval )

#define     port_internal_to_external( dpid, internal, external ) \
           Empty_directive( dpid, internal, external )
#define     port_external_to_internal( dpid, external, internal ) \
           Empty_directive( dpid, external, internal )
#define     port_create( name, intaddr, extaddr, length, dpid ) \
           Empty_directive( name, intaddr, extaddr, length, dpid )
#define     port_delete( dpid ) \
           Empty_directive( dpid )
#define     port_ident( name, dpid ) \
           Empty_directive( name, dpid )

#define     event_receive( eventin, options, timeout, eventout ) \
           Empty_directive( eventin, options, timeout, eventout )
#define     event_send( tid, event ) \
           Empty_directive( tid, event )

#define     initialize_executive( conftbl, cputbl ) \
           Empty_directive( conftbl, cputbl )
#define     shutdown_executive( the_error ) \
           Empty_directive( the_error )

#define     interrupt_catch( israddr, vector, oldisr ) \
           Empty_directive( israddr, vector, oldisr ) 

#define     partition_create( name, paddr, length, bsize, attr, ptid ) \
           Empty_directive( name, paddr, length, bsize, attr, ptid )
#define     partition_delete( ptid ) \
           Empty_directive( ptid )
#define     partition_get_buffer( ptid, bufaddr ) \
           Empty_directive( ptid, bufaddr )
#define     partition_ident( name, node, ptid ) \
           Empty_directive( name, node, ptid )
#define     partition_return_buffer( ptid, bufaddr ) \
           Empty_directive( ptid, bufaddr )

#define     message_queue_broadcast( qid, buffer, count ) \
           Empty_directive( qid, buffer, count )
#define     message_queue_create( name, count, attr, qid ) \
           Empty_directive( name, count, attr, qid )
#define     message_queue_delete( qid ) \
           Empty_directive( qid )
#define     message_queue_flush( qid, count ) \
           Empty_directive( qid, count )
#define     message_queue_ident( name, node, qid ) \
           Empty_directive( name, node, qid )
#define     message_queue_receive( qid, buffer, options, timeout ) \
           Empty_directive( qid, buffer, options, timeout )
#define     message_queue_send( qid, buffer ) \
           Empty_directive( qid, buffer )
#define     message_queue_urgent( qid, buffer ) \
           Empty_directive( qid, buffer )

#define     region_create( name, paddr, length, pagesize, attr, rnid ) \
           Empty_directive( name, paddr, length, pagesize, attr, rnid )
#define     region_delete( rnid ) \
           Empty_directive( rnid )
#define     region_get_segment( rnid, size, options, timeout, segaddr ) \
           Empty_directive( rnid, size, options, timeout, segaddr )
#define     region_ident( name, rnid ) \
           Empty_directive( name, rnid )
#define     region_return_segment( rnid, segaddr ) \
           Empty_directive( rnid, segaddr )

#define     semaphore_create( name, count, attr, smid ) \
           Empty_directive( name, count, attr, smid )
#define     semaphore_delete( smid ) \
           Empty_directive( smid )
#define     semaphore_ident( name, node, smid ) \
           Empty_directive( name, node, smid )
#define     semaphore_obtain( smid, options, timeout ) \
           Empty_directive( smid, options, timeout )
#define     semaphore_release( smid ) \
           Empty_directive( smid )

#define     task_create( name, priority, stack_size, mode, attr, tid ) \
           Empty_directive( name, priority, stack_size, mode, attr, tid )
#define     task_delete( tid ) \
           Empty_directive( tid )
#define     task_get_note( tid, notepad, note ) \
           Empty_directive( tid, notepad, note )
#define     task_ident( name, node, tid ) \
           Empty_directive( name, node, tid )
#define     task_mode( mode, mask, pmode ) \
           Empty_directive( mode, mask, pmode )
#define     task_restart( tid, arg ) \
           Empty_directive( tid, arg )
#define     task_resume( tid ) \
           Empty_directive( tid )
#define     task_set_note( tid, notepad, note ) \
           Empty_directive( tid, notepad, note )
#define     task_set_priority( tid, priority, ppriority ) \
           Empty_directive( tid, priority, ppriority )
#define     task_start( tid, saddr, arg ) \
           Empty_directive( tid, saddr, arg )
#define     task_suspend( tid ) \
           Empty_directive( tid )

#define     clock_get( time ) \
           Empty_directive( time )
#define     clock_set( time ) \
           Empty_directive( time )
#define     clock_tick() \
           Empty_directive()
#define     task_wake_after( ticks ) \
           Empty_directive( ticks )
#define     task_wake_when( time ) \
           Empty_directive( time )

#define     fatal_error_occurred( errcode ) \
           Empty_directive( errcode )

#define     rate_monotonic_create( name, id ) \
           Empty_directive( name, id )
#define     rate_monotonic_ident( name, id ) \
           Empty_directive( name, id )
#define     rate_monotonic_delete( id ) \
           Empty_directive( id )
#define     rate_monotonic_cancel( id ) \
           Empty_directive( id )
#define     rate_monotonic_period( id, period ) \
           Empty_directive( id, period )

#define     multiprocessing_announce() \
           Empty_directive() 

#define     timer_create( name, tmid ) \
           Empty_directive( name, tmid )
#define     timer_delete( tmid ) \
           Empty_directive( tmid )
#define     timer_cancel( tmid ) \
           Empty_directive( tmid )
#define     timer_ident( name, tmid ) \
           Empty_directive( name, tmid )
#define     timer_fire_after( tmid, ticks, routine, user_data ) \
           Empty_directive( tmid, ticks, routine, user_data )
#define     timer_fire_when( tmid, time, routine, user_data ) \
           Empty_directive( tmid, time, routine, user_data )
#define     timer_reset( tmid ) \
           Empty_directive( tmid )

rtems_status_code Empty_directive();

#endif
/* end of include file */
