/*
 *
 *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
 *  On-Line Applications Research Corporation (OAR).
 *  All rights assigned to U.S. Government, 1994.
 *
 *  This material may be reproduced by or for the U.S. Government pursuant
 *  to the copyright license under the clause at DFARS 252.227-7013.  This
 *  notice must appear in all copies of this file and its derivatives.
 *
 *  $Id$
 */

#include "system.h"
#undef EXTERN
#define EXTERN
#include "conftbl.h"
#include "gvar.h"

rtems_unsigned8 Memory_area[ 2048 ];
rtems_unsigned8 Internal_port_area[ 256 ];
rtems_unsigned8 External_port_area[ 256 ];

rtems_task Task_1(
  rtems_task_argument argument
);

rtems_task Init(
  rtems_task_argument argument
)
{ rtems_id id;
  rtems_status_code status;

  puts( "\n\n*** TIME TEST overhead ***" );

  status = task_create( 
    build_name( 'T', 'A', '1', ' ' ),
    254, 
    2048, 
    DEFAULT_MODES, 
    DEFAULT_ATTRIBUTES, 
    &id 
  );
  directive_failed( status, "task_create of TA1" );

  status = task_start( id, Task_1, 0 );
  directive_failed( status, "task_start of TA1" );

  status = task_delete( SELF );
  directive_failed( status, "task_delete of SELF" );
}

/* comment out the following include to verify type are correct */
#include "dumrtems.h"

rtems_timer_service_routine Timer_handler(
  rtems_id argument
)
{
}

rtems_asr Isr_handler(
  rtems_signal_set signals
) 
{
}

rtems_asr Asr_handler(
  rtems_signal_set signals
) 
{
}

rtems_task task_func() {}

void null_func() {}

rtems_status_code Empty_directive() 
{ 
  return( SUCCESSFUL ); 
}

rtems_task Task_1(
  rtems_task_argument argument
) 
{
  rtems_name                 name;
  rtems_unsigned32           index;
  rtems_cpu_table            cpu_table;
  rtems_id                   id;  
  rtems_task_priority        in_priority;
  rtems_task_priority        out_priority;
  rtems_mode                 in_mode;
  rtems_mode                 mask;
  rtems_mode                 out_mode;
  rtems_unsigned32           note;
  rtems_time_of_day          time;
  rtems_interval             timeout;
  rtems_signal_set           signals;
  void                      *address_1;
  rtems_event_set            events;
  long                       buffer[ 4 ];
  rtems_unsigned32           count;
  rtems_device_major_number  major;
  rtems_device_minor_number  minor;
  rtems_unsigned32           io_result;
  rtems_unsigned32           error;

  name        = build_name( 'N', 'A', 'M', 'E' );
  in_priority = 250;
  in_mode     = NO_PREEMPT;
  mask        = PREEMPT_MASK;
  note        = 8;
  timeout     = 100;
  signals     = SIGNAL_1 | SIGNAL_3;
  major       = 10;
  minor       = 0;
  error       = 100;

/* INITIALIZE_EXECUTIVE */
  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) initialize_executive( &Configuration, &cpu_table );
  end_time = Read_timer();

  put_time(
    "INITIALIZE_EXECUTIVE",
    end_time,
    OPERATION_COUNT,
    overhead,
    0
  );

/* SHUTDOWN_EXECUTIVE */

  Timer_initialize();
    for ( index=1 ; index <= OPERATION_COUNT ; index++ )
      (void) shutdown_executive( error );
  end_time = Read_timer();

  put_time(
    "SHUTDOWN_EXECUTIVE",
    end_time,
    OPERATION_COUNT,
    overhead,
    0
  );

/* TASK_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_create( 
               name, 
               in_priority, 
               2048, 
               DEFAULT_MODES, 
               DEFAULT_ATTRIBUTES, 
               &id
            );
      end_time = Read_timer();

      put_time( 
         "TASK_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_ident( name, SEARCH_ALL_NODES, id );
      end_time = Read_timer();

      put_time( 
         "TASK_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_START */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_start( id, Task_1, 0 );
      end_time = Read_timer();

      put_time( 
         "TASK_START",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_RESTART */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_restart( id, 0 );
      end_time = Read_timer();

      put_time( 
         "TASK_RESTART",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_delete( id );
      end_time = Read_timer();

      put_time( 
         "TASK_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_SUSPEND */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_suspend( id );
      end_time = Read_timer();

      put_time( 
         "TASK_SUSPEND",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_RESUME */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_resume( id );
      end_time = Read_timer();

      put_time( 
         "TASK_RESUME",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_SET_PRIORITY */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_set_priority( id, in_priority, &out_priority );
      end_time = Read_timer();

      put_time( 
         "TASK_SET_PRIORITY",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_MODE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_mode( in_mode, mask, &out_mode );
      end_time = Read_timer();

      put_time( 
         "TASK_MODE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_GET_NOTE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_get_note( id, 1, note );
      end_time = Read_timer();

      put_time( 
         "TASK_GET_NOTE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_SET_NOTE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_set_note( id, 1, note );
      end_time = Read_timer();

      put_time( 
         "TASK_SET_NOTE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_WAKE_WHEN */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_wake_when( time );
      end_time = Read_timer();

      put_time( 
         "TASK_WAKE_WHEN",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TASK_WAKE_AFTER */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) task_wake_after( timeout );
      end_time = Read_timer();

      put_time( 
         "TASK_WAKE_AFTER",
         end_time, 
         OPERATION_COUNT,
         overhead,
         0
      );

/* INTERRUPT_CATCH */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) interrupt_catch( Isr_handler, 5, address_1 );
      end_time = Read_timer();

      put_time( 
         "INTERRUPT_CATCH",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* CLOCK_GET */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) clock_get( time );
      end_time = Read_timer();

      put_time( 
         "CLOCK_GET",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* CLOCK_SET */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) clock_set( time );
      end_time = Read_timer();

      put_time( 
         "CLOCK_SET",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* CLOCK_TICK */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
           (void) clock_tick();
      end_time = Read_timer();

      put_time( 
         "CLOCK_TICK",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

pause();

/* TIMER_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_create( name, &id );
      end_time = Read_timer();

      put_time( 
         "TIMER_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_delete( id );
      end_time = Read_timer();

      put_time( 
         "TIMER_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_ident( name, id );
      end_time = Read_timer();

      put_time( 
         "TIMER_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_FIRE_AFTER */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_fire_after( 
               id, 
               timeout, 
               Timer_handler,
               NULL
            );
      end_time = Read_timer();

      put_time( 
         "TIMER_FIRE_AFTER",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_FIRE_WHEN */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_fire_when(
               id, 
               time, 
               Timer_handler,
               NULL
            );
      end_time = Read_timer();

      put_time( 
         "TIMER_FIRE_WHEN",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_RESET */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_reset( id );
      end_time = Read_timer();

      put_time( 
         "TIMER_RESET",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* TIMER_CANCEL */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) timer_cancel( id );
      end_time = Read_timer();

      put_time( 
         "TIMER_CANCEL",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SEMAPHORE_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) semaphore_create( 
               name, 
               128,
               DEFAULT_ATTRIBUTES,
               &id
            );
      end_time = Read_timer();

      put_time( 
         "SEMAPHORE_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SEMAPHORE_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) semaphore_delete( id );
      end_time = Read_timer();

      put_time( 
         "SEMAPHORE_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SEMAPHORE_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) semaphore_ident( name, SEARCH_ALL_NODES, id );
      end_time = Read_timer();

      put_time( 
         "SEMAPHORE_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SEMAPHORE_OBTAIN */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) semaphore_obtain( id, DEFAULT_OPTIONS, timeout );
      end_time = Read_timer();

      put_time( 
         "SEMAPHORE_OBTAIN",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SEMAPHORE_RELEASE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) semaphore_release( id );
      end_time = Read_timer();

      put_time( 
         "SEMAPHORE_RELEASE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_create( 
               name, 
               128,
               DEFAULT_ATTRIBUTES,
               &id
            );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_ident( name, SEARCH_ALL_NODES, id );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_delete( id );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_SEND */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_send( id, (long (*)[4])buffer );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_SEND",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_URGENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_urgent( id, (long (*)[4])buffer );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_URGENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_BROADCAST */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_broadcast( 
               id, 
               (long (*)[4])buffer, 
               &count 
            );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_BROADCAST",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_RECEIVE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_receive( 
               id, 
               (long (*)[4])buffer,
               DEFAULT_OPTIONS,
               timeout
            );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_RECEIVE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MESSAGE_QUEUE_FLUSH */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) message_queue_flush( id, &count );
      end_time = Read_timer();

      put_time( 
         "MESSAGE_QUEUE_FLUSH",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

pause();

/* EVENT_SEND */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) event_send( id, events );
      end_time = Read_timer();

      put_time( 
         "EVENT_SEND",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* EVENT_RECEIVE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) event_receive( 
               EVENT_16, 
               DEFAULT_OPTIONS,
               timeout,
               &events
            );
      end_time = Read_timer();

      put_time( 
         "EVENT_RECEIVE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SIGNAL_CATCH */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) signal_catch( Asr_handler, DEFAULT_MODES );
      end_time = Read_timer();

      put_time( 
         "SIGNAL_CATCH",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* SIGNAL_SEND */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) signal_send( id, signals );
      end_time = Read_timer();

      put_time( 
         "SIGNAL_SEND",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PARTITION_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) partition_create( 
               name, 
               Memory_area,
               2048,
               128,
               DEFAULT_ATTRIBUTES,
               &id
            );
      end_time = Read_timer();

      put_time( 
         "PARTITION_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PARTITION_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) partition_ident( name, SEARCH_ALL_NODES, id );
      end_time = Read_timer();

      put_time( 
         "PARTITION_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PARTITION_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) partition_delete( id );
      end_time = Read_timer();

      put_time( 
         "PARTITION_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PARTITION_GET_BUFFER */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) partition_get_buffer( id, address_1 );
      end_time = Read_timer();

      put_time( 
         "PARTITION_GET_BUFFER",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PARTITION_RETURN_BUFFER */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) partition_return_buffer( id, address_1 );
      end_time = Read_timer();

      put_time( 
         "PARTITION_RETURN_BUFFER",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* REGION_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) region_create( 
               name, 
               Memory_area,
               2048,
               128,
               DEFAULT_ATTRIBUTES,
               &id
            );
      end_time = Read_timer();

      put_time( 
         "REGION_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* REGION_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) region_ident( name, id );
      end_time = Read_timer();

      put_time( 
         "REGION_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* REGION_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) region_delete( id );
      end_time = Read_timer();

      put_time( 
         "REGION_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* REGION_GET_SEGMENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) region_get_segment( 
               id, 
               243,
               DEFAULT_OPTIONS,
               timeout,
               &address_1
            );
      end_time = Read_timer();

      put_time( 
         "REGION_GET_SEGMENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* REGION_RETURN_SEGMENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) region_return_segment( id, address_1 );
      end_time = Read_timer();

      put_time( 
         "REGION_RETURN_SEGMENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PORT_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) port_create( 
               name, 
               Internal_port_area,
               External_port_area,
               0xff,
               &id
            );
      end_time = Read_timer();

      put_time( 
         "PORT_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PORT_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) port_ident( name, id );
      end_time = Read_timer();

      put_time( 
         "PORT_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PORT_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) port_delete( id );
      end_time = Read_timer();

      put_time( 
         "PORT_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PORT_EXTERNAL_TO_INTERNAL */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) port_external_to_internal( 
               id, 
               &External_port_area[ 7 ],
               address_1
            );
      end_time = Read_timer();

      put_time( 
         "PORT_EXTERNAL_TO_INTERNAL",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* PORT_INTERNAL_TO_EXTERNAL */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) port_internal_to_external( 
               id, 
               &Internal_port_area[ 7 ],
               address_1
            );
      end_time = Read_timer();

      put_time( 
         "PORT_INTERNAL_TO_EXTERNAL",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

pause();

/* IO_INITIALIZE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_initialize( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_INITIALIZE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* IO_OPEN */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_open( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_OPEN",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* IO_CLOSE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_close( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_CLOSE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* IO_READ */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_read( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_READ",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* IO_WRITE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_write( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_WRITE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* IO_CONTROL */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) io_control( 
               major,
               minor,
               address_1,
               &io_result
            );
      end_time = Read_timer();

      put_time( 
         "IO_CONTROL",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* FATAL_ERROR_OCCURRED */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) fatal_error_occurred( error );
      end_time = Read_timer();

      put_time( 
         "FATAL_ERROR_OCCURRED",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* RATE_MONOTONIC_CREATE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) rate_monotonic_create( name, &id );
      end_time = Read_timer();

      put_time( 
         "RATE_MONOTONIC_CREATE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* RATE_MONOTONIC_IDENT */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) rate_monotonic_ident( name, id );
      end_time = Read_timer();

      put_time( 
         "RATE_MONOTONIC_IDENT",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* RATE_MONOTONIC_DELETE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) rate_monotonic_delete( id );
      end_time = Read_timer();

      put_time( 
         "RATE_MONOTONIC_DELETE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* RATE_MONOTONIC_CANCEL */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) rate_monotonic_cancel( id );
      end_time = Read_timer();

      put_time( 
         "RATE_MONOTONIC_CANCEL",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* RATE_MONOTONIC_PERIOD */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) rate_monotonic_period( id, timeout );
      end_time = Read_timer();

      put_time( 
         "RATE_MONOTONIC_PERIOD",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

/* MULTIPROCESSING_ANNOUNCE */

      Timer_initialize();
         for ( index = 1 ; index <= OPERATION_COUNT ; index ++ )
            (void) multiprocessing_announce();
      end_time = Read_timer();

      put_time( 
         "MULTIPROCESSING_ANNOUNCE",
         end_time, 
         OPERATION_COUNT, 
         overhead,
         0
      );

  puts( "*** END OF TIME OVERHEAD ***\n" );

  exit( 0 );
}
